#ifndef MODAL_DIALOG_H
#define MODAL_DIALOG_H

#pragma warn -8057

#define VERSION 1.34
#define BUFFER_SIZE 4224
#define CHARACTER_COUNT 8
#define FULL 0x0100
#define HELP_FILE_NAME "VOYA.HLP"
#define SALT_ARRAY_SIZE 82
#define SMALL_BUFFER_SIZE 50
#define VERSION_TEXT "version.txt"
#include <sstream>
#include <windows.h>
#include "voyaID.h"

class ModalDialog {
protected:
    HINSTANCE instance;
    HWND hwnd, hdwnd, infoLabel;
    int infoLabelHeight, infoLabelID, infoLabelWidth, infoLabelX, infoLabelY, width, height;
    _STL::string info;

public:
    virtual ~ModalDialog(){}

    void centering();
    void clear();
    void inform();
    void postMessage(int UM);
    void setWindowText(char *s);

    virtual BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam) = 0;
    virtual int modalDialog() = 0;
};

class VoyaVersion : public ModalDialog {
    const int INFO_LABEL_HEIGHT, VERSION_HEIGHT, VERSION_WIDTH;

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VoyaVersion(HINSTANCE i, HWND h);
};

BOOL CALLBACK versionDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
bool testSalt(int x);
bool testSalt(_STL::string & g);
void createVersionText(bool comments);

#endif // MODAL_DIALOG_H
