CC        = bcc32
LINKER    = ilink32
RC        = brcc32

INCLUDE = -I"C:\STLport-4.5.3\stlport;C:\borland\bcc55\Include"
LIB     = /L"C:\STLport-4.5.3\lib;C:\borland\bcc55\Lib"

CFLAGS = -O2 -w -tW
LFLAGS = /Tpe /c /aa
RFLAGS = -32

TARGET = voya.exe
OBJS   = controllable.obj crypt3.obj dividable.obj modaldialog.obj mt19937ar.obj voyacontrol.obj voyafile.obj voyasetting.obj voyasjis.obj voyatest.obj voyathread.obj 
RESFILES = voyathread.res

ALL : $(TARGET)

crypt3.obj: crypt3.cpp
	$(CC) -c crypt3.cpp
mt19937ar.obj: mt19937ar.cpp
	$(CC) -c mt19937ar.cpp
dividable.obj: Dividable.cpp
	$(CC) $(INCLUDE) -c Dividable.cpp
modaldialog.obj: ModalDialog.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ModalDialog.cpp
voyafile.obj: voyaFile.cpp
	$(CC) $(INCLUDE) -c voyaFile.cpp
controllable.obj: Controllable.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Controllable.cpp
voyacontrol.obj: voyaControl.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c voyaControl.cpp
voyasetting.obj: voyaSetting.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c voyaSetting.cpp
voyasjis.obj: voyaSjis.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c voyaSjis.cpp
voyatest.obj: voyaTest.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c voyaTest.cpp
voyathread.obj: voyaThread.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c voyaThread.cpp
voyathread.res: voyaThread.rc
	$(RC) $(RFLAGS) voyaThread.rc

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0w32.obj,$(TARGET),,cw32mt.lib import32.lib,,$(RESFILES)

clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
	del *.res
