#include "voyaFile.h"

bool metaCharacterIncluded(char *sequence) {
    int i, m;
    int meta[METACHARACTERS] = {0x5C, '^', '$', '.', '[', ']', '*', '+', '?' };
    for(m = 0; m < METACHARACTERS; ++m) {
        for(i = 0; sequence[i] != '\0'; ++i) {
            if(sequence[i] == meta[m]) {
                return true;
            }
        }
    }

    return false;
}

bool tenthCharacterOfTori(int tail) {
// the tenth character of 10-figure tori
    bool b = false;
    int m;
    int tenth[TENTH_CHARACTER] = {'.', '2', '6', 'A', 'E', 'I', 'M', 'Q', 'U', 'Y', 'c', 'g', 'k', 'o', 's', 'w'};
    for(m = 0; m < TENTH_CHARACTER; ++m) {
        if(tail == tenth[m]) {
            b = true;
            break;
        }
    }

    return b;
}

char *getLine(char *p, char *sequence) {
    int i = 0;
    while(*p != '\r') {
        sequence[i++] = *p;

        ++p;
        if(*p == '\0') {
            return NULL;
        }
    }

    sequence[i] = '\0';
    ++p; // \n
    ++p;
    return p;
}

char lowerCaseOf(int i) {
    char c;

    if('A' <= i && i <= 'Z') {
        c = (char)(i - 'A' + 'a');
    } else {
        c = (char)i;
    }

    return c;
}

char random_ascii(char *ascii) {
    char single;
    static int stage;
    static unsigned long eight_bit_group[10];
    unsigned long bits;

    switch(stage) {
    case 1:
        single = ascii[ eight_bit_group[2] ];
        stage += 1;
        break;
    case 2:
        single = ascii[ eight_bit_group[1] ];
        stage += 1;
        break;
    case 3:
        single = ascii[ eight_bit_group[0] ];
        stage = 0;
        break;
    default:
        bits = genrand_int32();
        eight_bit_group[0] = bits & 0x000000FF;
        bits >>= 8;
        eight_bit_group[1] = bits & 0x000000FF;
        bits >>= 8;
        eight_bit_group[2] = bits & 0x000000FF;
        bits >>= 8;
        eight_bit_group[3] = bits & 0x000000FF;

        single = ascii[ eight_bit_group[3] ];
        stage = 1;
    }

    return single;
}

char upperCaseOf(int i) {
    char c;

    if('a' <= i && i <= 'z') {
        c = (char)(i - 'a' + 'A');
    } else {
        c = (char)i;
    }

    return c;
}

int charToInteger(char c) {
    unsigned char uc = (unsigned char)c;
    int i = (int)uc;
    return i;
}

int cstring_to_integer(char *p) {
    char *b;
    char h[256];
    const int F = 0x7F;
    const int MINUS_SIGN = '-';
    const int TOO_LONG = -1;
    const int MAXIMUM = 10; // "2147483647"
    int d, e, i, length;
    bool minus_sign = false;

    if(*p == MINUS_SIGN) {
        ++p;
        minus_sign = true;
    }

    h[0] = F; h[1] = F; h[2] = F; h[3] = F; h[4] = F; h[5] = F; h[6] = F; h[7] = F; h[8] = F; h[9] = F; h[10] = F; h[11] = F; h[12] = F; h[13] = F; h[14] = F; h[15] = F; h[16] = F; h[17] = F; h[18] = F; h[19] = F;
    h[20] = F; h[21] = F; h[22] = F; h[23] = F; h[24] = F; h[25] = F; h[26] = F; h[27] = F; h[28] = F; h[29] = F; h[30] = F; h[31] = F; h[32] = F; h[33] = F; h[34] = F; h[35] = F; h[36] = F; h[37] = F; h[38] = F; h[39] = F;
    h[40] = F; h[41] = F; h[42] = F; h[43] = F; h[44] = F; h[45] = F; h[46] = F; h[47] = F; 
    h[48] = 0; h[49] = 1; h[50] = 2; h[51] = 3; h[52] = 4; h[53] = 5; h[54] = 6; h[55] = 7; h[56] = 8; h[57] = 9; 
    h[58] = F; h[59] = F;
    h[60] = F; h[61] = F; h[62] = F; h[63] = F; h[64] = F; h[65] = F; h[66] = F; h[67] = F; h[68] = F; h[69] = F; h[70] = F; h[71] = F; h[72] = F; h[73] = F; h[74] = F; h[75] = F; h[76] = F; h[77] = F; h[78] = F; h[79] = F;
    h[80] = F; h[81] = F; h[82] = F; h[83] = F; h[84] = F; h[85] = F; h[86] = F; h[87] = F; h[88] = F; h[89] = F; h[90] = F; h[91] = F; h[92] = F; h[93] = F; h[94] = F; h[95] = F; h[96] = F; h[97] = F; h[98] = F; h[99] = F;
    h[100] = F; h[101] = F; h[102] = F; h[103] = F; h[104] = F; h[105] = F; h[106] = F; h[107] = F; h[108] = F; h[109] = F; h[110] = F; h[111] = F; h[112] = F; h[113] = F; h[114] = F; h[115] = F; h[116] = F; h[117] = F; h[118] = F; h[119] = F;
    h[120] = F; h[121] = F; h[122] = F; h[123] = F; h[124] = F; h[125] = F; h[126] = F; h[127] = F; h[128] = F; h[129] = F; h[130] = F; h[131] = F; h[132] = F; h[133] = F; h[134] = F; h[135] = F; h[136] = F; h[137] = F; h[138] = F; h[139] = F;
    h[140] = F; h[141] = F; h[142] = F; h[143] = F; h[144] = F; h[145] = F; h[146] = F; h[147] = F; h[148] = F; h[149] = F; h[150] = F; h[151] = F; h[152] = F; h[153] = F; h[154] = F; h[155] = F; h[156] = F; h[157] = F; h[158] = F; h[159] = F;
    h[160] = F; h[161] = F; h[162] = F; h[163] = F; h[164] = F; h[165] = F; h[166] = F; h[167] = F; h[168] = F; h[169] = F; h[170] = F; h[171] = F; h[172] = F; h[173] = F; h[174] = F; h[175] = F; h[176] = F; h[177] = F; h[178] = F; h[179] = F;
    h[180] = F; h[181] = F; h[182] = F; h[183] = F; h[184] = F; h[185] = F; h[186] = F; h[187] = F; h[188] = F; h[189] = F; h[190] = F; h[191] = F; h[192] = F; h[193] = F; h[194] = F; h[195] = F; h[196] = F; h[197] = F; h[198] = F; h[199] = F;
    h[200] = F; h[201] = F; h[202] = F; h[203] = F; h[204] = F; h[205] = F; h[206] = F; h[207] = F; h[208] = F; h[209] = F; h[210] = F; h[211] = F; h[212] = F; h[213] = F; h[214] = F; h[215] = F; h[216] = F; h[217] = F; h[218] = F; h[219] = F;
    h[220] = F; h[221] = F; h[222] = F; h[223] = F; h[224] = F; h[225] = F; h[226] = F; h[227] = F; h[228] = F; h[229] = F; h[230] = F; h[231] = F; h[232] = F; h[233] = F; h[234] = F; h[235] = F; h[236] = F; h[237] = F; h[238] = F; h[239] = F;
    h[240] = F; h[241] = F; h[242] = F; h[243] = F; h[244] = F; h[245] = F; h[246] = F; h[247] = F; h[248] = F; h[249] = F; h[250] = F; h[251] = F; h[252] = F; h[253] = F; h[254] = F; h[255] = F; 

    b = p;
    length = 0;
    while(*b != '\0') {
        length += 1;
        if(length > MAXIMUM) {
            return TOO_LONG;
        }

        ++b;
    }

    e = 0;
    for(i = 0; i < length; ++i) {
        d = p[i];
        if(h[d] == F) {
            break;
        }

        e = 10*e + h[d];
    }

    if(minus_sign) {
        e = -1*e;
    }

    return e;
}

int hexadecimal_cstring_to_integer(char *p) {
    char *b;
    char h[256];
    const int F = 0x7F;
    const int MINUS_SIGN = '-';
    const int TOO_LONG = -1;
    const int MAXIMUM = 10; // "2147483647"
    int d, e, i, length;
    bool minus_sign = false;

    if(*p == MINUS_SIGN) {
        ++p;
        minus_sign = true;
    }

    h[0] = F; h[1] = F; h[2] = F; h[3] = F; h[4] = F; h[5] = F; h[6] = F; h[7] = F; h[8] = F; h[9] = F; h[10] = F; h[11] = F; h[12] = F; h[13] = F; h[14] = F; h[15] = F; h[16] = F; h[17] = F; h[18] = F; h[19] = F;
    h[20] = F; h[21] = F; h[22] = F; h[23] = F; h[24] = F; h[25] = F; h[26] = F; h[27] = F; h[28] = F; h[29] = F; h[30] = F; h[31] = F; h[32] = F; h[33] = F; h[34] = F; h[35] = F; h[36] = F; h[37] = F; h[38] = F; h[39] = F;
    h[40] = F; h[41] = F; h[42] = F; h[43] = F; h[44] = F; h[45] = F; h[46] = F; h[47] = F; 
    h[48] = 0; h[49] = 1; h[50] = 2; h[51] = 3; h[52] = 4; h[53] = 5; h[54] = 6; h[55] = 7; h[56] = 8; h[57] = 9; 
    h[58] = F; h[59] = F;
    h[60] = F; h[61] = F; h[62] = F; h[63] = F; h[64] = F; 
    h[65] = 10; h[66] = 11; h[67] = 12; h[68] = 13; h[69] = 14; h[70] = 15; 
    h[71] = F; h[72] = F; h[73] = F; h[74] = F; h[75] = F; h[76] = F; h[77] = F; h[78] = F; h[79] = F;
    h[80] = F; h[81] = F; h[82] = F; h[83] = F; h[84] = F; h[85] = F; h[86] = F; h[87] = F; h[88] = F; h[89] = F; h[90] = F; h[91] = F; h[92] = F; h[93] = F; h[94] = F; h[95] = F; h[96] = F; 
    h[97] = 10; h[98] = 11; h[99] = 12; h[100] = 13; h[101] = 14; h[102] = 15; 
    h[103] = F; h[104] = F; h[105] = F; h[106] = F; h[107] = F; h[108] = F; h[109] = F; h[110] = F; h[111] = F; h[112] = F; h[113] = F; h[114] = F; h[115] = F; h[116] = F; h[117] = F; h[118] = F; h[119] = F;
    h[120] = F; h[121] = F; h[122] = F; h[123] = F; h[124] = F; h[125] = F; h[126] = F; h[127] = F; h[128] = F; h[129] = F; h[130] = F; h[131] = F; h[132] = F; h[133] = F; h[134] = F; h[135] = F; h[136] = F; h[137] = F; h[138] = F; h[139] = F;
    h[140] = F; h[141] = F; h[142] = F; h[143] = F; h[144] = F; h[145] = F; h[146] = F; h[147] = F; h[148] = F; h[149] = F; h[150] = F; h[151] = F; h[152] = F; h[153] = F; h[154] = F; h[155] = F; h[156] = F; h[157] = F; h[158] = F; h[159] = F;
    h[160] = F; h[161] = F; h[162] = F; h[163] = F; h[164] = F; h[165] = F; h[166] = F; h[167] = F; h[168] = F; h[169] = F; h[170] = F; h[171] = F; h[172] = F; h[173] = F; h[174] = F; h[175] = F; h[176] = F; h[177] = F; h[178] = F; h[179] = F;
    h[180] = F; h[181] = F; h[182] = F; h[183] = F; h[184] = F; h[185] = F; h[186] = F; h[187] = F; h[188] = F; h[189] = F; h[190] = F; h[191] = F; h[192] = F; h[193] = F; h[194] = F; h[195] = F; h[196] = F; h[197] = F; h[198] = F; h[199] = F;
    h[200] = F; h[201] = F; h[202] = F; h[203] = F; h[204] = F; h[205] = F; h[206] = F; h[207] = F; h[208] = F; h[209] = F; h[210] = F; h[211] = F; h[212] = F; h[213] = F; h[214] = F; h[215] = F; h[216] = F; h[217] = F; h[218] = F; h[219] = F;
    h[220] = F; h[221] = F; h[222] = F; h[223] = F; h[224] = F; h[225] = F; h[226] = F; h[227] = F; h[228] = F; h[229] = F; h[230] = F; h[231] = F; h[232] = F; h[233] = F; h[234] = F; h[235] = F; h[236] = F; h[237] = F; h[238] = F; h[239] = F;
    h[240] = F; h[241] = F; h[242] = F; h[243] = F; h[244] = F; h[245] = F; h[246] = F; h[247] = F; h[248] = F; h[249] = F; h[250] = F; h[251] = F; h[252] = F; h[253] = F; h[254] = F; h[255] = F; 

    b = p;
    length = 0;
    while(*b != '\0') {
        length += 1;
        if(length > MAXIMUM) {
            return TOO_LONG;
        }

        ++b;
    }

    e = 0;
    for(i = 0; i < length; ++i) {
        d = p[i];
        if(h[d] == F) {
            break;
        }

        e = 16*e + h[d];
    }

    if(minus_sign) {
        e = -1*e;
    }

    return e;
}

int removeComment(char *sequence) {
    int i;
    for(i = 0; sequence[i] != '\0'; ++i) {
        if(sequence[i] == '#') {
            sequence[i] = '\0';
            break;
        } else if(sequence[i] == 0x27) { // quote ( ' )
            sequence[i] = '\0';
            break;
        }
    }

    return i;
}

int sumOfWeight(double sum) {
    const double LIMIT = 65536.0; // unsigned 16-bit integers
    const int TOO_LARGE = -1;
    int s;
    if(sum > LIMIT) {
        s = TOO_LARGE;
    } else {
        s = (int)sum;
    }

    return s;
}

unsigned long randomIndex() {
    static bool upper;
    static unsigned long two_bytes;
    unsigned long bits, u;

    if(upper) {
        u = two_bytes;
        upper = false;
    } else {
        bits = genrand_int32();
        two_bytes = bits & 0x0000FFFF;
        u = bits >> 16;
        upper = true;
    }

    return u;
}

void copyThree(char *part, char *digits, int i) {
    for(int k = 0; k < 3; ++k, ++i) {
        part[k] = digits[i];
    }

    part[3] = '\0';
}

void random_salt(char *pair, char *salt) {
    static bool phase;
    static unsigned long seven_bit_group[4];
    unsigned long bits;

    if(phase) {
        pair[0] = salt[ seven_bit_group[1] ];
        pair[1] = salt[ seven_bit_group[0] ];
        pair[2] = '\0';
        phase = false;
    } else {
        bits = genrand_int32();
        seven_bit_group[0] = bits & 0x0000007F;
        bits >>= 7;
        seven_bit_group[1] = bits & 0x0000007F;
        bits >>= 7;
        seven_bit_group[2] = bits & 0x0000007F;
        bits >>= 7;
        seven_bit_group[3] = bits & 0x0000007F;

        pair[0] = salt[ seven_bit_group[3] ];
        pair[1] = salt[ seven_bit_group[2] ];
        pair[2] = '\0';
        phase = true;
    }

}

void setMT(long n, int repetition) {
    char digits[ DIGITS_SIZE + 1 ] = {'0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '\0'};
    char part0[4];
    char part1[4];
    char part2[4];
    char part3[4];
    const long ten = 10L;
    int i, index;
    long dividend, r;
    unsigned long init[SEED_LENGTH];

    if(n == TIME_USED_AS_SEED) {
        n = tickCount();
    }

    dividend = n;
    for(i = 0; i < DIGITS_SIZE; ++i) {
        index = DIGITS_SIZE - 1 - i;
        n = dividend/ten;
        r = dividend%ten; // dividend = n * ten + r
        digits[index] = r + '0';
        if(n == 0L) {
            break;
        }

        dividend = n;
    }

/*
0123456789
1339415048;
    415   ;
     150  ;
      504 ;
       048;
*/
    copyThree(part0, digits, 4);
    init[0] = hexadecimal_cstring_to_integer(part0);
    copyThree(part1, digits, 5);
    init[1] = hexadecimal_cstring_to_integer(part1);
    copyThree(part2, digits, 6);
    init[2] = hexadecimal_cstring_to_integer(part2);
    copyThree(part3, digits, 7);
    init[3] = hexadecimal_cstring_to_integer(part3);
    init_by_array(init, SEED_LENGTH);

// idling
    for(i = 0; i < repetition; ++i) { 
        genrand_int32();
    }
}

