#ifndef VOYA_SETTING_H
#define VOYA_SETTING_H

#pragma warn -8057

#define AEIM_CHARACTER 13
#define ARRAY_LENGTH 28
#define CGKO_CHARACTER 6
#define CSV_COLUMN_COUNT 2
#define REPEATEDLY_NORMALIZING 30
#define SALT_LINE 31
#define SHOULD_BE_USED_AS_TENTH_CHARACTER "., 2, 6, A, E, I, M, Q, U, Y, c, g, k, o, s or w should be used as the tenth character of tori."
#define VOYA_CSV "voya.csv"
#define WEIGHT_ARRAY_LENGTH 24
#include <fstream>
#include <iostream>
#include <sstream>
#include "Controllable.h"
#include "Dividable.h"
#include "ModalDialog.h"
#include "struct_vs.h"
#include "voyaID.h"

enum VOYA_CSV_LINES {UNAVAILABLE, REQUEST_LINE, LOG_LINE, LEFTMOST_LINE, CASE_SENSITIVE_LINE, REPORT_LINE, IDLING_LINE, ASCII_LINE};

class VoyaDetails : public ModalDialog {
    const int INFO_LABEL_HEIGHT, DETAILS_HEIGHT, DETAILS_WIDTH;

    bool readDetails();
    void normalizing(double sum, double aim);
    void writeVoyaCSV();

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VoyaDetails(HINSTANCE i, HWND h);
};

BOOL CALLBACK detailsDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);

class VoyaSetting : public ModalDialog {
    const int INFO_LABEL_HEIGHT, SETTING_HEIGHT, SETTING_WIDTH;

    bool readSetting();
    bool writeVoyaCSV();

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VoyaSetting(HINSTANCE i, HWND h);
};

BOOL CALLBACK settingDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
bool copyLogFileName(char *, int);
bool copyRequest(char *, int);
bool copySalt(char *sequence, int end);
bool createRemoveErrorText();
bool metaCharacterIncluded(char *sequence);
bool readLabels();
bool removeSalt();
bool settingBy(const char *fileName);
bool tenthCharacterOfTori(int tail);
bool testSalt(int x);
char *getLine(char *p, char *line);
double shiftJisKanaAscii(); // voyaThread.cpp
int commaShouldComeBeforeInteger(char *, int, int);
int cstring_to_integer(char *p);
int removeComment(char *line);
int sumOfWeight(double sum);
unsigned long randomIndex();
void copyThree(char *part, char *digits, int i);
void editedLinePrint(int line, int a);
void normalizing(double sum, double aim);
void recovery();
void setMT(long n, int repetition);
void useLowerCaseUnlessCaseSensitive();
void useNoCharacterButASCII();
void writeLabelsEditedLines();

#endif // VOYA_SETTING_H
