#ifndef VOYASJIS_H
#define VOYASJIS_H

#pragma warn -8057

#define BINARY_FILE "sjis.bin"
#define FROM_TO " -> "
#define KANA_KUTEN 0xA1
#define REVERSE 1680 // BUFFER_SIZE > REVERSE
#define SJIS_ABANDON " | \r\n"
#define SJIS_RING_COUNT 22
#define VOYA_LOG "voya.log"
#include <deque>
#include <fstream>
#include <iostream>
#include <math.h>
#include <sstream>
#include <vector>
#include "ModalDialog.h"
#include "voyaID.h"

typedef _STL::deque<_STL::string> RING;

class VoyaSjis : public ModalDialog {
    const int INFO_LABEL_HEIGHT, SJIS_HEIGHT, SJIS_WIDTH;
    int ring_count;
    _STL::string BLANK;
    _STL::string textBox[SJIS_RING_COUNT];

    bool convertRawKeysIntoShiftJIS(const char *voya_log);
    bool writeSjis();
    int produceRingBuffer(int size);
    long logSize();
    RING sjisRing;
    void seekEndReverse();
    void setFileName();
    void showRing();

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VoyaSjis(HINSTANCE i, HWND h);
};

BOOL CALLBACK sjisDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
bool testSalt(int x);
bool zenkakuFragment(char *buffer);
int charToInteger(char c);
void set_byte_table();

#endif // VOYASJIS_H
