#include "voyaThread.h"

/*
voya Win32API Version 1.34
To find requested tori.
Copyright 2015 Sogaya

Borland C++ 5.5.1 for Win32
STLport-4.5.3

*/

Controllable *thread;
extern VOYA_SETTING *vs; // voyaSetting.cpp
HANDLE semapho;
RING ring;
volatile bool displayEntrusted;
volatile bool terminated; // Controllable.cpp
VOYA_CONTROL voyaControl;
VOYA_CONTROL *vc = &voyaControl;
VoyaControl *control;
VoyaDetails *details;
VoyaSetting *setting;
VoyaSjis *sjis;
VoyaTest *test;
VoyaVersion *version;

namespace {
    bool *hugeTable; // hugeTable[HALF][HALF][HALF]
    bool inside, longPane, leftmost_salt, messages, removeFirst, smallWindow, showWhere, titleBarText, toBeNormalized, universalTime, useAscii, widePane;
    char areaText[BUFFER_SIZE];
    char ascii_set[ASCII_SET_ARRAY_SIZE] =    {'!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '&', '"', 0x27, '<', '>', ' ', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '&', '"', 0x27, '<', '>', ' ', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g'};
    char ascii_subset[ASCII_SET_ARRAY_SIZE] = {'!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ')', '*',  '+', '-', '.', '/', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ')', '*',  '+', '-', '.', '/', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g'};
    char c[TABLE_SIZE][KANJI_SIZE_PLUS_ONE]; // list of characters
    char character[EXTENDED_TABLE_SIZE][KANJI_SIZE_PLUS_ONE];
    char salt_set[SALT_SET_ARRAY_SIZE] =    {'!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '$', '%', '&', ' ', 0x2C, '"', 0x27, '!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a'};
    char salt_subset[SALT_SET_ARRAY_SIZE] = {'!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '$', '%', '*', '+',  '-', '.',  '/', '!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a'};
    char reverseComplement[ TEN_FIGURE_TORI + 1 ];
    char titleBar[SMALL_BUFFER_SIZE]; // small window
    char voyaThreadNumber[SMALL_BUFFER_SIZE];
    char waiting[SMALL_BUFFER_SIZE]; // showRing(hwnd) sets the text of panel[2].
    const BOOL REPAINT = TRUE;
    const double AIM = 30000.;
    const int DEFAULT_PERIOD = 9;
    const int DEFAULT_PRIORITY = 2;
    const int DIAGONAL_CORNER = 3;
    const int LOWER_LIMIT = 2; // DEFAULT_PERIOD = 9
    const int NON_SAMPLING_PERIOD = 3000;
    const int PRELIMINARY_THREAD = -2;
    const int RING_COUNT = 22;
    const int SMALL_RING_COUNT = 6;
    const std::string EMPTY("");
    FILETIME untouched;
    HWND statusBar, textArea, whereLabel;
    int bound, corner, main_height, main_width, main_x, main_y, period, priority, ring_count, seconds, standard_main_x, standard_main_y, textAreaHeight, threadNumber;
    int w[TABLE_SIZE]; // weight list
    int width[EXTENDED_TABLE_SIZE];
}

BOOL CALLBACK smallDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam) {
    BOOL b = 0;
    HWND stopButton;

    switch(message) {
    case WM_COMMAND:
        switch( LOWORD(wParam) ) {
        case IDCANCEL:
            if( thread->closing() ) {
                thread->postMessage(WM_DESTROY);
                delete thread;
            } // Stop the thread before closing

            b = TRUE;
            break;
        case IDV_STOP: // Stop
            thread->stop();
            b = TRUE;
            break;
        case IDV_RENEW:
            thread->postMessage(UM_RENEW);
            b = TRUE;
            break;
        }

        break;
    case WM_INITDIALOG:
        stopButton = CreateWindow(
            "BUTTON",
            "Stop",
            WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,
            SMALL_BUTTON_X,
            SMALL_BUTTON_Y,
            SMALL_BUTTON_WIDTH,
            SMALL_BUTTON_HEIGHT,
            hdwnd,
            (HMENU)IDV_STOP,
            vs->instance,
            NULL
        );

        vs->stopButton = stopButton;
        b = TRUE;
        break;
    }

    return b;
}

bool readTitleBarText() {
    char *p;
    char buffer[BUFFER_SIZE];
    char c[SMALL_BUFFER_SIZE];
    unsigned long length;

    HANDLE text = ::CreateFile(TITLE_BAR_TEXT, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(text == INVALID_HANDLE_VALUE) {
        return false;
    } else {
        ::ReadFile(text, buffer, sizeof(buffer), &length, NULL);
        p = &buffer[0];
        if(*p != '\0') {
            p = getLine(p, c);
            if(p == NULL) {
                lstrcpy(vc->titleBarMessage, PLEASE_WAIT_TWO);
            } else {
                lstrcpy(vc->titleBarMessage, c);
            }

        } else {
            lstrcpy(vc->titleBarMessage, PLEASE_WAIT_TWO);
        }

    }

    ::CloseHandle(text);
    return true;
}

bool readVoyaCtrlTextBeforeCreatingWindow() {
    char *p;
    char buffer[BUFFER_SIZE];
    char c[SMALL_BUFFER_SIZE];
    int i = INSIDE_LINE;
    int seconds;
    int setting[VOYA_MODES_LIST_SIZE];
    unsigned long length;

    HANDLE text = ::CreateFile(VOYA_CTRL_TEXT, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(text == INVALID_HANDLE_VALUE) {
        return false;
    } else {
        for(int i = 0; i < VOYA_MODES_LIST_SIZE; ++i) {
            setting[i] = 0;
        }

        ::ReadFile(text, buffer, sizeof(buffer), &length, NULL);
        p = &buffer[0];
        while(*p != '\0') {
            p = getLine(p, c);
            if(p == NULL) {
                break;
            }

            setting[i] = cstring_to_integer(c);

            if(++i >= VOYA_MODES_LIST_SIZE) {
                break;
            }

        }

        switch(setting[INSIDE_LINE]) {
        case 0:
            vc->inside = false;
            break;
        default:
            vc->inside = true;
            break;
        }

        switch(setting[MESSAGES_LINE]) {
        case 0:
            vc->messages = false;
            break;
        default:
            vc->messages = true;
            break;
        }

        vc->priority = setting[PRIORITY_LINE];

        switch(setting[UTC_LINE]) {
        case 0:
            vc->universalTime = false;
            break;
        default:
            vc->universalTime = true;
            break;
        }

        vc->corner = setting[CORNER_LINE];
        seconds = setting[PERIOD_LINE];
        if(seconds <= LOWER_LIMIT) {
            seconds = DEFAULT_PERIOD;
        }

        vc->period = 1000 * seconds;

        switch(setting[SMALL_WINDOW_LINE]) {
        case 0:
            vc->smallWindow = false;
            break;
        default:
            vc->smallWindow = true;
            break;
        }

        switch(setting[TITLE_BAR_LINE]) {
        case 0:
            vc->titleBarText = false;
            break;
        default:
            vc->titleBarText = true;
            break;
        }

        switch(setting[LEFTMOST_SALT_LINE]) {
        case 0:
            vc->leftmostSalt = false;
            break;
        default:
            vc->leftmostSalt = true;
            break;
        }

        switch(setting[QUOTES_GREATER_THAN_LINE]) {
        case 0:
            vc->excludeQuotesGreaterThan = false;
            break;
        default:
            vc->excludeQuotesGreaterThan = true;
            break;
        }

        ::CloseHandle(text);
    }

    return true;
}

bool repeating() {
    int i, k, measured;
    static int d;

// Setting a list of repeated items
    for(i = 0; i < bound; ++i) {
        measured = lstrlen(&c[i][0]);
        for(k = 0; k < w[i]; ++k) {
            lstrcpy(&character[d][0], &c[i][0]);
            width[d] = measured;
            if(++d >= EXTENDED_TABLE_SIZE) {
                return false;
            }
        }
    }

    return true;
}

bool setByTriplet(int k, int m, int n) {
// hugeTable + k * HALF * HALF + m * HALF + n;

    m <<= 7; // m *= 128
    k <<= 14; // k *= 16384

    bool* p = hugeTable + k + m + n;
    bool old = *p;
    *p = true;
    return old;
}

bool threePlaces(int k, int m, int n) {
// hugeTable + k * HALF * HALF + m * HALF + n;

    m <<= 7; // m *= 128
    k <<= 14; // k *= 16384

    bool* p = hugeTable + k + m + n;
    return *p;
}

bool voyaCtrlTextTouched() {
    bool touched;
    FILETIME file_time;

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

// Checking if VOYA_CTRL_TEXT exists
    HANDLE text = ::CreateFile(VOYA_CTRL_TEXT, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(text == INVALID_HANDLE_VALUE) {
        touched = true;
    } else {
        ::GetFileTime(text, NULL, NULL, &file_time);

// Checking if VOYA_CTRL_TEXT has been modified
        if(file_time.dwLowDateTime == untouched.dwLowDateTime) {
            touched = false;
        } else {
            touched = true;
        }

        ::CloseHandle(text);
    }

    return touched;
}

double shiftJisKanaAscii() {
    char *ascii;
    const int LOWER_BYTE = 0x00FF;
    int higher, lower;
    int d = 0;

    double sum = 0.0;
    for(int i = 0x8140; i <= 0x81AC; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->parallel_weight;
        sum += (double)w[d];
    }

    for(int i = 0x81B8; i <= 0x81BF; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->cap_weight;
        sum += (double)w[d];
    }

    for(int i = 0x81C8; i <= 0x81CE; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->exists_weight;
        sum += (double)w[d];
    }

    for(int i = 0x81DA; i <= 0x81E8; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->double_integral_weight;
        sum += (double)w[d];
    }

    for(int i = 0x81F0; i <= 0x81F7; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->paragraph_weight;
        sum += (double)w[d];
    }

    int m = 0x81FC; // 
    lower = m & LOWER_BYTE;
    higher = m >> 8;
    c[d][0] = higher;
    c[d][1] = lower;
    c[d][2] = '\0';
    w[d] = vs->circle_weight;
    sum += (double)w[d];
    d++;

    for(int i = 0x824F; i <= 0x8258; ++i, ++d) { // X
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->nine_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8260; i <= 0x8279; ++i, ++d) { // y
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->capital_z_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8281; i <= 0x829A; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->z_weight;
        sum += (double)w[d];
    }

    for(int i = 0x829F; i <= 0x82F1; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->hiragana_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8340; i <= 0x8396; ++i, ++d) { // 
        if(i == 0x837F) {
            continue;
        }

        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->katakana_weight;
        sum += (double)w[d];
    }

    for(int i = 0x839F; i <= 0x83B6; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->capital_omega_weight;
        sum += (double)w[d];
    }

    for(int i = 0x83BF; i <= 0x83D6; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->omega_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8440; i <= 0x8460; ++i, ++d) { // `
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->capital_ya_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8470; i <= 0x8491; ++i) { // 
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->ya_weight;
        sum += (double)w[d];
        d++;
    }

    for(int i = 0x849F; i <= 0x84BE; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->keisen_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8740; i <= 0x875D; ++i, ++d) { // ]
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->roman_weight;
        sum += (double)w[d];
    }

    for(int i = 0x875F; i <= 0x8775; ++i, ++d) { // u
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->square_meter_weight;
        sum += (double)w[d];
    }

    int n = 0x877E; // ~
    lower = n & LOWER_BYTE;
    higher = n >> 8;
    c[d][0] = higher;
    c[d][1] = lower;
    c[d][2] = '\0';
    w[d] = vs->heisei_weight;
    sum += (double)w[d];
    d++;

    for(int i = 0x8780; i <= 0x879C; ++i, ++d) { // 
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->cup_weight;
        sum += (double)w[d];
    }

    for(int i = 0x889F; i <= 0x88FC; ++i, ++d) { // JIS level-1 kanji set starts idling 0x889F (  )
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_one_kanji_weight;
        sum += (double)w[d];
    }

    for(int i = 0x8940; i <= 0x9FFC; ++i) {
        if(0x9873 <=i && i <= 0x989E) { // JIS level-2 kanji set starts idling 0x989F (  )
            continue;
        }

        lower = i & LOWER_BYTE;
        if(lower < 0x40) {
            continue;
        } else if(lower == 0x7F) {
            continue;
        } else if(0xFD <= lower) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(int i = 0xE040; i <= 0xE9FC; ++i) {
        lower = i & LOWER_BYTE;
        if(lower < 0x40) {
            continue;
        } else if(lower == 0x7F) {
            continue;
        } else if(0xFD <= lower) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(int i = 0xEA40; i <= 0xEAA4; ++i) {
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(int i = 0xED40; i <= 0xEDFC; ++i) {
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(int i = 0xEE40; i <= 0xEEEC; ++i) {
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(int i = 0xEEEF; i <= 0xEEFC; ++i, ++d) {
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
    }

// hankaku katakana
    for(int i = 0xA1; i <= 0xDF; ++i, ++d) { // 
        c[d][0] = i;
        c[d][1] = '\0';
        c[d][2] = '\0';
        w[d] = vs->hankaku_katakana_weight;
        sum += (double)w[d];
    }

/* ASCII */
    if(vc->excludeQuotesGreaterThan) {
/* 
Excluding five symbols: " ' > < & 
*/
        ascii = &ascii_subset[0];
    } else {
        ascii = &ascii_set[0];
    }

    for(int i = 0; i < ASCII_COUNT; ++i, ++d) { /*  !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~ */
        c[d][0] = ascii[i];
        c[d][1] = '\0';
        c[d][2] = '\0';
        w[d] = vs->ascii_weight;
        sum += (double)w[d];
    }

    bound = d;
    return sum;
}

DragonSeek::DragonSeek(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Dragon seek");
}

DWORD WINAPI DragonSeek::ThreadFunc(LPVOID param) {
    using namespace _STL;

    char *body;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char head[4][2];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char quartet[4][SMALL_BUFFER_SIZE];
    char request[REQUEST_SIZE];
    char tail[4][2];
    const bool BREAK = false;
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    u = lstrlen(request);

/* 
012345678901
^[Rr]uda[/.]
*/
    head[0][0] = request[2];
    head[0][1] = '\0';
    tail[0][0] = request[ u - 3 ];
    tail[0][1] = '\0';

    head[1][0] = request[2];
    head[1][1] = '\0';
    tail[1][0] = request[ u - 2 ];
    tail[1][1] = '\0';

    head[2][0] = request[3];
    head[2][1] = '\0';
    tail[2][0] = request[ u - 3 ];
    tail[2][1] = '\0';

    head[3][0] = request[3];
    head[3][1] = '\0';
    tail[3][0] = request[ u - 2 ];
    tail[3][1] = '\0';

    request[ u - 4 ] = '\0';
    for(int i = 0; i < 4; ++i) {
        q = & quartet[i][0];
        body = & request[5];

        lstrcpy(q, &head[i][0]);
        lstrcat(q, body);
        lstrcat(q, &tail[i][0]);
    }

    string QUARTET0(quartet[0]);
    string QUARTET1(quartet[1]);
    string QUARTET2(quartet[2]);
    string QUARTET3(quartet[3]);

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        delete p;
        p = new string(&q[s]); // tori

/* 
^[hH]body[tT]
head: h or H
body: fixed string
tail: t or T

^[Rr]uda[/.], for example.
*/
        do {
            u = p->find(QUARTET0);
            if(u != string::npos) {
                break;
            }

            u = p->find(QUARTET1);
            if(u != string::npos) {
                break;
            }

            u = p->find(QUARTET2);
            if(u != string::npos) {
                break;
            }

            u = p->find(QUARTET3);
            if(u != string::npos) {
                break;
            }

        } while(BREAK);

        if(u == string::npos) {
            continue;
        } else if(u > 0) {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI LeftmostSalt::ThreadFunc(LPVOID param) {
    using namespace _STL;

    bool case_sensitive;
    char *ascii_array;
    char *q;
    char *salt;
    char *salt_array;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// Huge table set by triplet so that threePlaces() can read boolean values
    HGLOBAL handle = ::GlobalAlloc(GHND, HALF * HALF * HALF);
    hugeTable = (bool *) ::GlobalLock(handle);
    if(hugeTable == NULL) {
        voyaFlush("hugeTable == NULL");
        ::FreeLibrary(cryptGNU);
        closeVoyaError();
        return 1;
    }

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    int request_length = lstrlen(request);
    if(request_length < 3) {
        strcat(request, COMPLEMENT);
        request[3] = '\0';
    }

    string REQUEST(request);
    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(request[0], request[1], request[2]);
    } else {
        setByTriplet(request[0], request[1], request[2]);
        setByTriplet(request[0], request[1], upperCaseOf(request[2]) );
        setByTriplet(request[0], upperCaseOf(request[1]), request[2]);
        setByTriplet(request[0], upperCaseOf(request[1]), upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), request[1], request[2]);
        setByTriplet( upperCaseOf(request[0]), request[1], upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), request[2]);
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), upperCaseOf(request[2]) );
    }

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    if(vc->excludeQuotesGreaterThan) {
/* 
Excluding five symbols: " ' > < & 
*/
        ascii_array = &ascii_subset[0];
        salt_array = &salt_subset[0];
    } else {
        ascii_array = &ascii_set[0];
        salt_array = &salt_set[0];
    }

    salt = & vs->salt[0];
    if( strlen(salt) == 0 ) {
        random_salt(salt, salt_array);
    }

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = random_ascii(ascii_array);
        pass[1] = '\0';
        s = 1;

        strcat(pass, salt);
        s += SALT_SIZE;

        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, salt);
        s = lstrlen(q) - TEN_FIGURE_TORI;

        if( threePlaces(q[s], q[ s + 1 ], q[ s + 2 ]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    delete p;
                    p = new string(&q[s]); // tori
                } else {
                    lstrcpy(buffer, &q[s]); // tori
                    ::CharLower(buffer);
                    delete p;
                    p = new string(buffer);
                }

                u = p->find(REQUEST);
                if(u == string::npos) {
                    continue;
                } else if(u > 0) {
                    continue;
                }

            }

        } else {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        strcat(buffer, salt);
        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::GlobalFree(handle);
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI LeftmostThread::ThreadFunc(LPVOID param) {
    using namespace _STL;

    bool case_sensitive;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// Huge table set by triplet so that threePlaces() can read boolean values
    HGLOBAL handle = ::GlobalAlloc(GHND, HALF * HALF * HALF);
    hugeTable = (bool *) ::GlobalLock(handle);
    if(hugeTable == NULL) {
        voyaFlush("hugeTable == NULL");
        ::FreeLibrary(cryptGNU);
        closeVoyaError();
        return 1;
    }

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    int request_length = lstrlen(request);
    if(request_length < 3) {
        strcat(request, COMPLEMENT);
        request[3] = '\0';
    }

    string REQUEST(request);
    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(request[0], request[1], request[2]);
    } else {
        setByTriplet(request[0], request[1], request[2]);
        setByTriplet(request[0], request[1], upperCaseOf(request[2]) );
        setByTriplet(request[0], upperCaseOf(request[1]), request[2]);
        setByTriplet(request[0], upperCaseOf(request[1]), upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), request[1], request[2]);
        setByTriplet( upperCaseOf(request[0]), request[1], upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), request[2]);
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), upperCaseOf(request[2]) );
    }

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        if( threePlaces(q[s], q[ s + 1 ], q[ s + 2 ]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    delete p;
                    p = new string(&q[s]); // tori
                } else {
                    lstrcpy(buffer, &q[s]); // tori
                    ::CharLower(buffer);
                    delete p;
                    p = new string(buffer);
                }

                u = p->find(REQUEST);
                if(u == string::npos) {
                    continue;
                } else if(u > 0) {
                    continue;
                }

            }

        } else {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::GlobalFree(handle);
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI PreliminaryThread::ThreadFunc(LPVOID param) {
// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    if(vs->idling < 0) {
        voyaFlush("vs->idling < 0");
        closeVoyaError();
        return 1;
    }

    if(vs->interim_report < 1) {
        voyaFlush("vs->interim_report < 1");
        closeVoyaError();
        return 1;
    }

// Getting time information
    char dayOfWeek[7][4] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
    char buffer[BUFFER_SIZE];
    SYSTEMTIME systemTime;

    if(universalTime) { // UTC or GMT
        ::GetSystemTime(&systemTime);
    } else {
        ::GetLocalTime(&systemTime);
    }

    int dd = systemTime.wDay;
    int h = systemTime.wHour;
    int m = systemTime.wMinute;
    int mm = systemTime.wMonth;
    int sec = systemTime.wSecond;
    int wd = systemTime.wDayOfWeek;
    int y = systemTime.wYear;

    char *p = &dayOfWeek[wd][0];
    wsprintf(buffer, "%04d-%02d-%02d(%s) %02d:%02d:%02d", y, mm, dd, p, h, m, sec);

    if(universalTime) {
        lstrcat(buffer, " GMT");
    }

    lstrcat(buffer, NON_TORI_LINE);
    voyaFlush(buffer);

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    if(cryptGNU == NULL) {
        voyaFlush("cryptGNU == NULL");
        closeVoyaError();
        return 1;
    }

    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");
    if(crypt == NULL) {
        voyaFlush("crypt == NULL");
        closeVoyaError();
        return 1;
    }

    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI RegularExpression::ThreadFunc(LPVOID param) {
    using namespace _STL;

    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s;
    int count = 0;
    int efforts = 0;
    TRegexp *r;
    unsigned int len;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    r = new TRegexp(request);
    switch( r->status() ) {
    case TRegexp::OK:
        break;
    case TRegexp::ILLEGAL:
        voyaFlush("case ILLEGAL:");
        closeVoyaError();
        return 1;
    case TRegexp::NOMEMORY:
        voyaFlush("case NOMEMORY:");
        closeVoyaError();
        return 1;
    case TRegexp::TOOLONG:
        voyaFlush("case TOOLONG:");
        closeVoyaError();
        return 1;
    default:
        break;
    }

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        lstrcpy(buffer, &q[s]); // tori
        r->find(buffer, &len); // r = new TRegexp(request);
        if(len > 0) {
            ;
        } else {
            continue;
        }

        lstrcpy(matched, buffer);
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    delete r;
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI RightmostThread::ThreadFunc(LPVOID param) {
    using namespace _STL;

    bool case_sensitive;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// Huge table set by triplet so that threePlaces() can read boolean values
    HGLOBAL handle = ::GlobalAlloc(GHND, HALF * HALF * HALF);
    hugeTable = (bool *) ::GlobalLock(handle);
    if(hugeTable == NULL) {
        voyaFlush("hugeTable == NULL");
        ::FreeLibrary(cryptGNU);
        closeVoyaError();
        return 1;
    }

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    char tseu[ TSEU_LENGTH + 1 ];
    char toriTail[ TSEU_LENGTH + 1 ];
    int request_length = lstrlen(request);
    int reverseLength;
    if(request_length < 3) {
        lstrcpy(reverseComplement, REVERSE_COMPLEMENT);
        lstrcat(reverseComplement, request);
        reverseLength = lstrlen(reverseComplement);
        request[3] = '\0';
        request[2] = reverseComplement[ reverseLength - 1 ];
        request[1] = reverseComplement[ reverseLength - 2 ];
        request[0] = reverseComplement[ reverseLength - 3 ];
        request_length = 3;
    }

    string REQUEST(request);
    vector<char> v;
    vector<char>::reverse_iterator i;
    copy(request, request + request_length, back_inserter(v) );
    i = v.rbegin();
    for(int e = 0; e < TSEU_LENGTH; ++e) {
        tseu[e] = *i;
        ++i;
    }

    tseu[TSEU_LENGTH] = '\0';
    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
    } else {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
        setByTriplet(tseu[2], tseu[1], upperCaseOf(tseu[0]) );
        setByTriplet(tseu[2], upperCaseOf(tseu[1]), tseu[0]);
        setByTriplet(tseu[2], upperCaseOf(tseu[1]), upperCaseOf(tseu[0]) );
        setByTriplet( upperCaseOf(tseu[2]), tseu[1], tseu[0]);
        setByTriplet( upperCaseOf(tseu[2]), tseu[1], upperCaseOf(tseu[0]) );
        setByTriplet( upperCaseOf(tseu[2]), upperCaseOf(tseu[1]), tseu[0]);
        setByTriplet( upperCaseOf(tseu[2]), upperCaseOf(tseu[1]), upperCaseOf(tseu[0]) );
    }

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        lstrcpy(buffer, &q[s]); // tori
        v.clear();
        copy(buffer, buffer + TEN_FIGURE_TORI, back_inserter(v) );
        i = v.rbegin();
        for(int e = 0; e < TSEU_LENGTH; ++e) {
            toriTail[e] = *i;
            ++i;
        }

        if( threePlaces(toriTail[2], toriTail[1], toriTail[0]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    delete p;
                    p = new string(&q[s]); // tori
                } else {
                    ::CharLower(buffer);
                    delete p;
                    p = new string(buffer);
                }

                u = p->find(REQUEST);
                if(u != TEN_FIGURE_TORI - TSEU_LENGTH) {
                    continue;
                }

            }

        } else {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::GlobalFree(handle);
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI StandardThread::ThreadFunc(LPVOID param) {
    using namespace _STL;

    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    string REQUEST(request);

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        delete p;
        p = new string(&q[s]); // tori
        u = p->find(REQUEST);
        if(u == string::npos) {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI startSuspendThread(LPVOID param) {
    return thread->ThreadFunc(param);
}

DWORD WINAPI UnlessCaseSensitive::ThreadFunc(LPVOID param) {
    using namespace _STL;

    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    string REQUEST(request);

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        lstrcpy(buffer, &q[s]); // tori
        ::CharLower(buffer);
        delete p;
        p = new string(buffer);
        u = p->find(REQUEST);
        if(u == string::npos) {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

DWORD WINAPI UpperCaseRightmost::ThreadFunc(LPVOID param) {
    using namespace _STL;

    bool case_sensitive;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    int c, idling, interim_report, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;

// request
    if( settingBy(VOYA_CSV) ){
        readLabels();
        int request_length = lstrlen(vs->request);
        if( request_length < 1 ) {
            voyaFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            lstrcpy(request, vs->request);
        }

    } else {
        voyaFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return 1;
    }

// positive numbers
    idling = vs->idling;
    if(idling < 0) {
        voyaFlush("idling < 0");
        closeVoyaError();
        return 1;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaFlush("interim_report < 1");
        closeVoyaError();
        return 1;
    }

// GNU crypt.dll
    HMODULE cryptGNU = ::LoadLibrary("crypt.dll");
    CRYPT crypt = (CRYPT) ::GetProcAddress(cryptGNU, "crypt");

// Huge table set by triplet so that threePlaces() can read boolean values
    HGLOBAL handle = ::GlobalAlloc(GHND, HALF * HALF * HALF);
    hugeTable = (bool *) ::GlobalLock(handle);
    if(hugeTable == NULL) {
        voyaFlush("hugeTable == NULL");
        ::FreeLibrary(cryptGNU);
        closeVoyaError();
        return 1;
    }

// hexadecimal
    lstrcpy(&h[  0][0], "00"); lstrcpy(&h[  1][0], "01"); lstrcpy(&h[  2][0], "02"); lstrcpy(&h[  3][0], "03"); lstrcpy(&h[  4][0], "04"); lstrcpy(&h[  5][0], "05"); lstrcpy(&h[  6][0], "06"); lstrcpy(&h[  7][0], "07"); lstrcpy(&h[  8][0], "08"); lstrcpy(&h[  9][0], "09"); lstrcpy(&h[ 10][0], "0A"); lstrcpy(&h[ 11][0], "0B");
    lstrcpy(&h[ 12][0], "0C"); lstrcpy(&h[ 13][0], "0D"); lstrcpy(&h[ 14][0], "0E"); lstrcpy(&h[ 15][0], "0F"); lstrcpy(&h[ 16][0], "10"); lstrcpy(&h[ 17][0], "11"); lstrcpy(&h[ 18][0], "12"); lstrcpy(&h[ 19][0], "13"); lstrcpy(&h[ 20][0], "14"); lstrcpy(&h[ 21][0], "15"); lstrcpy(&h[ 22][0], "16"); lstrcpy(&h[ 23][0], "17");
    lstrcpy(&h[ 24][0], "18"); lstrcpy(&h[ 25][0], "19"); lstrcpy(&h[ 26][0], "1A"); lstrcpy(&h[ 27][0], "1B"); lstrcpy(&h[ 28][0], "1C"); lstrcpy(&h[ 29][0], "1D"); lstrcpy(&h[ 30][0], "1E"); lstrcpy(&h[ 31][0], "1F"); lstrcpy(&h[ 32][0], "20"); lstrcpy(&h[ 33][0], "21"); lstrcpy(&h[ 34][0], "22"); lstrcpy(&h[ 35][0], "23");
    lstrcpy(&h[ 36][0], "24"); lstrcpy(&h[ 37][0], "25"); lstrcpy(&h[ 38][0], "26"); lstrcpy(&h[ 39][0], "27"); lstrcpy(&h[ 40][0], "28"); lstrcpy(&h[ 41][0], "29"); lstrcpy(&h[ 42][0], "2A"); lstrcpy(&h[ 43][0], "2B"); lstrcpy(&h[ 44][0], "2C"); lstrcpy(&h[ 45][0], "2D"); lstrcpy(&h[ 46][0], "2E"); lstrcpy(&h[ 47][0], "2F");
    lstrcpy(&h[ 48][0], "30"); lstrcpy(&h[ 49][0], "31"); lstrcpy(&h[ 50][0], "32"); lstrcpy(&h[ 51][0], "33"); lstrcpy(&h[ 52][0], "34"); lstrcpy(&h[ 53][0], "35"); lstrcpy(&h[ 54][0], "36"); lstrcpy(&h[ 55][0], "37"); lstrcpy(&h[ 56][0], "38"); lstrcpy(&h[ 57][0], "39"); lstrcpy(&h[ 58][0], "3A"); lstrcpy(&h[ 59][0], "3B");
    lstrcpy(&h[ 60][0], "3C"); lstrcpy(&h[ 61][0], "3D"); lstrcpy(&h[ 62][0], "3E"); lstrcpy(&h[ 63][0], "3F"); lstrcpy(&h[ 64][0], "40"); lstrcpy(&h[ 65][0], "41"); lstrcpy(&h[ 66][0], "42"); lstrcpy(&h[ 67][0], "43"); lstrcpy(&h[ 68][0], "44"); lstrcpy(&h[ 69][0], "45"); lstrcpy(&h[ 70][0], "46"); lstrcpy(&h[ 71][0], "47");
    lstrcpy(&h[ 72][0], "48"); lstrcpy(&h[ 73][0], "49"); lstrcpy(&h[ 74][0], "4A"); lstrcpy(&h[ 75][0], "4B"); lstrcpy(&h[ 76][0], "4C"); lstrcpy(&h[ 77][0], "4D"); lstrcpy(&h[ 78][0], "4E"); lstrcpy(&h[ 79][0], "4F"); lstrcpy(&h[ 80][0], "50"); lstrcpy(&h[ 81][0], "51"); lstrcpy(&h[ 82][0], "52"); lstrcpy(&h[ 83][0], "53");
    lstrcpy(&h[ 84][0], "54"); lstrcpy(&h[ 85][0], "55"); lstrcpy(&h[ 86][0], "56"); lstrcpy(&h[ 87][0], "57"); lstrcpy(&h[ 88][0], "58"); lstrcpy(&h[ 89][0], "59"); lstrcpy(&h[ 90][0], "5A"); lstrcpy(&h[ 91][0], "5B"); lstrcpy(&h[ 92][0], "5C"); lstrcpy(&h[ 93][0], "5D"); lstrcpy(&h[ 94][0], "5E"); lstrcpy(&h[ 95][0], "5F");
    lstrcpy(&h[ 96][0], "60"); lstrcpy(&h[ 97][0], "61"); lstrcpy(&h[ 98][0], "62"); lstrcpy(&h[ 99][0], "63"); lstrcpy(&h[100][0], "64"); lstrcpy(&h[101][0], "65"); lstrcpy(&h[102][0], "66"); lstrcpy(&h[103][0], "67"); lstrcpy(&h[104][0], "68"); lstrcpy(&h[105][0], "69"); lstrcpy(&h[106][0], "6A"); lstrcpy(&h[107][0], "6B");
    lstrcpy(&h[108][0], "6C"); lstrcpy(&h[109][0], "6D"); lstrcpy(&h[110][0], "6E"); lstrcpy(&h[111][0], "6F"); lstrcpy(&h[112][0], "70"); lstrcpy(&h[113][0], "71"); lstrcpy(&h[114][0], "72"); lstrcpy(&h[115][0], "73"); lstrcpy(&h[116][0], "74"); lstrcpy(&h[117][0], "75"); lstrcpy(&h[118][0], "76"); lstrcpy(&h[119][0], "77");
    lstrcpy(&h[120][0], "78"); lstrcpy(&h[121][0], "79"); lstrcpy(&h[122][0], "7A"); lstrcpy(&h[123][0], "7B"); lstrcpy(&h[124][0], "7C"); lstrcpy(&h[125][0], "7D"); lstrcpy(&h[126][0], "7E"); lstrcpy(&h[127][0], "7F"); lstrcpy(&h[128][0], "80"); lstrcpy(&h[129][0], "81"); lstrcpy(&h[130][0], "82"); lstrcpy(&h[131][0], "83");
    lstrcpy(&h[132][0], "84"); lstrcpy(&h[133][0], "85"); lstrcpy(&h[134][0], "86"); lstrcpy(&h[135][0], "87"); lstrcpy(&h[136][0], "88"); lstrcpy(&h[137][0], "89"); lstrcpy(&h[138][0], "8A"); lstrcpy(&h[139][0], "8B"); lstrcpy(&h[140][0], "8C"); lstrcpy(&h[141][0], "8D"); lstrcpy(&h[142][0], "8E"); lstrcpy(&h[143][0], "8F");
    lstrcpy(&h[144][0], "90"); lstrcpy(&h[145][0], "91"); lstrcpy(&h[146][0], "92"); lstrcpy(&h[147][0], "93"); lstrcpy(&h[148][0], "94"); lstrcpy(&h[149][0], "95"); lstrcpy(&h[150][0], "96"); lstrcpy(&h[151][0], "97"); lstrcpy(&h[152][0], "98"); lstrcpy(&h[153][0], "99"); lstrcpy(&h[154][0], "9A"); lstrcpy(&h[155][0], "9B");
    lstrcpy(&h[156][0], "9C"); lstrcpy(&h[157][0], "9D"); lstrcpy(&h[158][0], "9E"); lstrcpy(&h[159][0], "9F"); lstrcpy(&h[160][0], "A0"); lstrcpy(&h[161][0], "A1"); lstrcpy(&h[162][0], "A2"); lstrcpy(&h[163][0], "A3"); lstrcpy(&h[164][0], "A4"); lstrcpy(&h[165][0], "A5"); lstrcpy(&h[166][0], "A6"); lstrcpy(&h[167][0], "A7");
    lstrcpy(&h[168][0], "A8"); lstrcpy(&h[169][0], "A9"); lstrcpy(&h[170][0], "AA"); lstrcpy(&h[171][0], "AB"); lstrcpy(&h[172][0], "AC"); lstrcpy(&h[173][0], "AD"); lstrcpy(&h[174][0], "AE"); lstrcpy(&h[175][0], "AF"); lstrcpy(&h[176][0], "B0"); lstrcpy(&h[177][0], "B1"); lstrcpy(&h[178][0], "B2"); lstrcpy(&h[179][0], "B3");
    lstrcpy(&h[180][0], "B4"); lstrcpy(&h[181][0], "B5"); lstrcpy(&h[182][0], "B6"); lstrcpy(&h[183][0], "B7"); lstrcpy(&h[184][0], "B8"); lstrcpy(&h[185][0], "B9"); lstrcpy(&h[186][0], "BA"); lstrcpy(&h[187][0], "BB"); lstrcpy(&h[188][0], "BC"); lstrcpy(&h[189][0], "BD"); lstrcpy(&h[190][0], "BE"); lstrcpy(&h[191][0], "BF");
    lstrcpy(&h[192][0], "C0"); lstrcpy(&h[193][0], "C1"); lstrcpy(&h[194][0], "C2"); lstrcpy(&h[195][0], "C3"); lstrcpy(&h[196][0], "C4"); lstrcpy(&h[197][0], "C5"); lstrcpy(&h[198][0], "C6"); lstrcpy(&h[199][0], "C7"); lstrcpy(&h[200][0], "C8"); lstrcpy(&h[201][0], "C9"); lstrcpy(&h[202][0], "CA"); lstrcpy(&h[203][0], "CB");
    lstrcpy(&h[204][0], "CC"); lstrcpy(&h[205][0], "CD"); lstrcpy(&h[206][0], "CE"); lstrcpy(&h[207][0], "CF"); lstrcpy(&h[208][0], "D0"); lstrcpy(&h[209][0], "D1"); lstrcpy(&h[210][0], "D2"); lstrcpy(&h[211][0], "D3"); lstrcpy(&h[212][0], "D4"); lstrcpy(&h[213][0], "D5"); lstrcpy(&h[214][0], "D6"); lstrcpy(&h[215][0], "D7");
    lstrcpy(&h[216][0], "D8"); lstrcpy(&h[217][0], "D9"); lstrcpy(&h[218][0], "DA"); lstrcpy(&h[219][0], "DB"); lstrcpy(&h[220][0], "DC"); lstrcpy(&h[221][0], "DD"); lstrcpy(&h[222][0], "DE"); lstrcpy(&h[223][0], "DF"); lstrcpy(&h[224][0], "E0"); lstrcpy(&h[225][0], "E1"); lstrcpy(&h[226][0], "E2"); lstrcpy(&h[227][0], "E3");
    lstrcpy(&h[228][0], "E4"); lstrcpy(&h[229][0], "E5"); lstrcpy(&h[230][0], "E6"); lstrcpy(&h[231][0], "E7"); lstrcpy(&h[232][0], "E8"); lstrcpy(&h[233][0], "E9"); lstrcpy(&h[234][0], "EA"); lstrcpy(&h[235][0], "EB"); lstrcpy(&h[236][0], "EC"); lstrcpy(&h[237][0], "ED"); lstrcpy(&h[238][0], "EE"); lstrcpy(&h[239][0], "EF");
    lstrcpy(&h[240][0], "F0"); lstrcpy(&h[241][0], "F1"); lstrcpy(&h[242][0], "F2"); lstrcpy(&h[243][0], "F3"); lstrcpy(&h[244][0], "F4"); lstrcpy(&h[245][0], "F5"); lstrcpy(&h[246][0], "F6"); lstrcpy(&h[247][0], "F7"); lstrcpy(&h[248][0], "F8"); lstrcpy(&h[249][0], "F9"); lstrcpy(&h[250][0], "FA"); lstrcpy(&h[251][0], "FB");
    lstrcpy(&h[252][0], "FC"); lstrcpy(&h[253][0], "FD"); lstrcpy(&h[254][0], "FE"); lstrcpy(&h[255][0], "FF");

// request
    char tseu[ TSEU_LENGTH + 1 ];
    char toriTail[ TSEU_LENGTH + 1 ];
    int request_length = lstrlen(request);
    int reverseLength;
    if(request_length < 3) {
        lstrcpy(reverseComplement, REVERSE_COMPLEMENT);
        lstrcat(reverseComplement, request);
        reverseLength = lstrlen(reverseComplement);
        request[3] = '\0';
        request[2] = reverseComplement[ reverseLength - 1 ];
        request[1] = reverseComplement[ reverseLength - 2 ];
        request[0] = reverseComplement[ reverseLength - 3 ];
        request_length = 3;
    }

    string REQUEST(request);
    vector<char> v;
    vector<char>::reverse_iterator i;
    copy(request, request + request_length, back_inserter(v) );
    i = v.rbegin();
    for(int e = 0; e < TSEU_LENGTH; ++e) {
        tseu[e] = *i;
        ++i;
    }

    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
    } else {
        tseu[TSEU_LENGTH] = '\0';
        setByTriplet(tseu[2], tseu[1], tseu[0]);
        setByTriplet(tseu[2], tseu[1], lowerCaseOf(tseu[0]) );
        setByTriplet(tseu[2], lowerCaseOf(tseu[1]), tseu[0]);
        setByTriplet(tseu[2], lowerCaseOf(tseu[1]), lowerCaseOf(tseu[0]) );
        setByTriplet( lowerCaseOf(tseu[2]), tseu[1], tseu[0]);
        setByTriplet( lowerCaseOf(tseu[2]), tseu[1], lowerCaseOf(tseu[0]) );
        setByTriplet( lowerCaseOf(tseu[2]), lowerCaseOf(tseu[1]), tseu[0]);
        setByTriplet( lowerCaseOf(tseu[2]), lowerCaseOf(tseu[1]), lowerCaseOf(tseu[0]) );
    }

// Setting a list of repeated items
    double sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

// Setting Mersenne Twister (MT)
    setMT(TIME_USED_AS_SEED, idling);

    string *p = new string("");
    lstrcpy(waiting, PLEASE_WAIT);
    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

// Generating random numbers to produce a key
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { // s may not equal 8 or 9.
            d = randomIndex();
            lstrcat(pass, &character[d][0]);
            s += width[d];
        }

// Encrypting to produce a tori
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, ".."); // crypt() is faster than crypt3().
        s = lstrlen(q) - TEN_FIGURE_TORI;

        lstrcpy(buffer, &q[s]); // tori
        v.clear();
        copy(buffer, buffer + TEN_FIGURE_TORI, back_inserter(v) );
        i = v.rbegin();
        for(int e = 0; e < TSEU_LENGTH; ++e) {
            toriTail[e] = *i;
            ++i;
        }

        if( threePlaces(toriTail[2], toriTail[1], toriTail[0]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    delete p;
                    p = new string(&q[s]); // tori
                } else {
                    ::CharUpper(buffer);
                    delete p;
                    p = new string(buffer);
                }

                u = p->find(REQUEST);
                if(u != TEN_FIGURE_TORI - TSEU_LENGTH) {
                    continue;
                }

            }

        } else {
            continue;
        }

        lstrcpy(matched, &q[s]); // tori
        count += 1;

// Expressing the key as hexadecimal
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            lstrcat(buffer, &h[c][0]); // hexadecimal
            ++q;
        }

        lstrcat(buffer, FROM_TO);
        lstrcat(buffer, matched);
        voyaFlush(buffer);

        wsprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        delete p;
        p = new string(buffer);
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            ring.pop_front();
            ring.push_back(*p);
            ::ReleaseSemaphore(semapho, 1, NULL);
        }

    }

    lstrcpy(waiting, TO_SEARCH);

// Entrust display to the GUI thread
    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    delete p;
    ::GlobalFree(handle);
    ::FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int produceRingBuffer(const char *message, int upper_limit) {
    using namespace _STL;

    string BLANK(" ");
    string MESSAGE(message);
    ring.clear();
    for(int i = 0; i < upper_limit; i += 2) {
        ring.push_back(BLANK);
        ring.push_back(MESSAGE);
    }

    return ring.size();
}

int produceRingBuffer(int size) {
    using namespace _STL;

    string BLANK(" ");
    ring.clear();
    for(int i = 0; i < size; i += 1) {
        ring.push_back(BLANK);
    }

    return ring.size();
}

int WINAPI WinMain(HINSTANCE instance, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode) {
    using namespace _STL;

    if( readVoyaCtrlTextBeforeCreatingWindow() ) {
        inside = vc->inside;
        messages = vc->messages;
        priority = vc->priority;
        universalTime = vc->universalTime;
        corner = vc->corner;
        period = vc->period;
        smallWindow = vc->smallWindow;
        titleBarText = vc->titleBarText;
        leftmost_salt = vc->leftmostSalt;
    } else {
        return 0;
    }

    HANDLE text = ::CreateFile(VOYA_LOG, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(text == INVALID_HANDLE_VALUE) {
        createVoyaLog();
    } else {
        ::CloseHandle(text);
    }

    useAscii = false;
    removeFirst = false;
    toBeNormalized = false;

// command line
    bool quit = false;
    const bool WITHOUT_COMMENTS = false;
    const bool WITH_COMMENTS = true;
    const int ARG_COUNT = 12;
    const int PARAMETER_SIZE = 2;
    const string ASCII("-a");
    const string BAR("-b");
    const string CORNER("-c");
    const string EXCLUDE("-x");
    const string GMT("-g"); // universal time (UTC)
    const string INSIDE("-i");
    const string MESSAGES("-m-");
    const string NORMALIZE("-n");
    const string PERIOD("-p");
    const string PRIORITY("-o");
    const string QUIT("-q");
    const string RECOVERY("-y");
    const string REMOVE("-r");
    const string SALT("-l");
    const string SMALL("-s");
    const string THROUGH("-t");
    const string version("-V");
    const string version_comment("-VC");
    const string WIDE("-w");
    Numbered *n = new Numbered("-c3");
    string non_number;
    string argv[ARG_COUNT];
    string command( ::GetCommandLine() );
    Dividing t(command);
    int argc = t.itemCount();
    argv[0] = t.a(0);
    argv[1] = t.a(1);
    argv[2] = t.a(2);
    argv[3] = t.a(3);
    argv[4] = t.a(4);
    argv[5] = t.a(5);
    argv[6] = t.a(6);
    argv[7] = t.a(7);
    argv[8] = t.a(8);
    argv[9] = t.a(9);
    argv[10] = t.a(10);
    argv[11] = t.a(11);

    for(int i = 0; i < argc; ++i) {
        if(ASCII == argv[i]) {
            useAscii = true;
        } else if(BAR == argv[i]) {
            titleBarText = true;
        } else if(EXCLUDE == argv[i]) {
            vc->excludeQuotesGreaterThan = true;
        } else if(GMT == argv[i]) {
            universalTime = true; // PreliminaryThread::ThreadFunc()
        } else if(INSIDE == argv[i]) {
            inside = true;
        } else if(MESSAGES == argv[i]) {
            messages = false;
        } else if(NORMALIZE == argv[i]) {
            toBeNormalized = true;
        } else if(QUIT == argv[i]) {
            quit = true;
        } else if(RECOVERY == argv[i]) {
            recovery();
        } else if(REMOVE == argv[i]) {
            removeFirst = true;
        } else if(SALT == argv[i]) {
            leftmost_salt = true;
        } else if(SMALL == argv[i]) {
            smallWindow = true;
        } else if(THROUGH == argv[i]) {
            showWhere = true;
        } else if(version == argv[i]) {
            createVersionText(WITHOUT_COMMENTS);
            return 0;

        } else if(version_comment == argv[i]) {
            createVersionText(WITH_COMMENTS);
            return 0;

        } else if(WIDE == argv[i]) {
            widePane = true;
        } else {
            if( argv[i].length() > PARAMETER_SIZE ) {
                delete n;
                n = new Numbered(argv[i]);
                non_number = n->parameter();

                if(CORNER == non_number) {
                    corner = n->number();
                    if(corner < 1 || 4 < corner) {
                        corner = DIAGONAL_CORNER;
                    }

                } else if(PERIOD == non_number) {
                    seconds = n->number();
                    if(seconds <= LOWER_LIMIT) {
                        seconds = DEFAULT_PERIOD;
                    }

                    period = 1000 * seconds;
                } else if(PRIORITY == non_number) {
                    priority = n->number();
                    if(priority < 1 || 5 < priority) {
                        priority = DEFAULT_PRIORITY;
                    }

                }

            }

        }

    }

    delete n;

    if(leftmost_salt) {
        useAscii = true;
    }

    if(removeFirst) {
        removeVoyaErrorFiles();
        ::DeleteFile(REMOVE_ERROR_TEXT);
    }

    if(titleBarText) {
        readTitleBarText();
    } else {
        lstrcpy(vc->titleBarMessage, PLEASE_WAIT_TWO);
    }

    if(quit) {
        return 0;
    }

    vs->leftmost_salt = leftmost_salt;
    vs->non_sampling = NON_SAMPLING_PERIOD;
    vs->removeVoyaError = messages;
    vs->searchWhenMovingInside = inside;
    vs->thread_priority = priority;

// Creating a window
    char windowName[] = "Thread Window";
    WNDCLASSEX wcl;

    wcl.cbSize = sizeof(WNDCLASSEX); 
    wcl.hInstance = instance;
    wcl.lpszClassName = windowName;
    wcl.lpfnWndProc = WindowFunc;
    wcl.style = 0;
    wcl.hIcon = ::LoadIcon(instance, "voya_icon");
    wcl.hIconSm = NULL;
    wcl.hCursor = ::LoadCursor(NULL, IDC_ARROW);
    wcl.cbClsExtra = 0;
    wcl.cbWndExtra = 0;
    wcl.hbrBackground = (HBRUSH) ::GetStockObject(WHITE_BRUSH); 
    HWND hwnd;
    if(smallWindow) {
        wcl.lpszMenuName = NULL;
        if(! ::RegisterClassEx(&wcl) ) {
            return 0;
        }

// width, height
        main_width = SMALL_WINDOW_WIDTH;
        main_height = SMALL_WINDOW_HEIGHT;

        standard_main_x = MAIN_X;
        standard_main_y = MAIN_Y;
        const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
        const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
        int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
        screen_height += MENU_HEIGHT;

        switch(corner) {
        case 1:
            main_x = 0;
            main_y = 0;
            break;
        case 2:
            main_x = SCREEN_WIDTH - main_width;
            main_y = 0;
            break;
        case 3:
            main_x = SCREEN_WIDTH - main_width;
            main_y = screen_height - main_height;
            break;
        case 4:
            main_x = 0;
            main_y = screen_height - main_height;
            break;
        default:
            main_x = SCREEN_WIDTH/2 - main_width/2;
            main_y = screen_height/2 - main_height/2;
            break;
        }

        hwnd = ::CreateWindow(
            windowName,
            "",
            WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
            main_x,
            main_y,
            main_width,
            main_height,
            NULL,
            NULL,
            instance,
            NULL
        );

    } else {
        wcl.lpszMenuName = "voyaMenu";
        if(! ::RegisterClassEx(&wcl) ) {
            return 0;
        }

// width, height
        if(widePane) {
            main_width = WIDE_PANE;
        } else {
            main_width = MAIN_WIDTH;
        }

        main_height = MAIN_HEIGHT;

        standard_main_x = MAIN_X;
        standard_main_y = MAIN_Y;
        const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
        const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
        int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
        screen_height += MENU_HEIGHT;

        switch(corner) {
        case 1:
            main_x = 0;
            main_y = 0;
            break;
        case 2:
            main_x = SCREEN_WIDTH - main_width;
            main_y = 0;
            break;
        case 3:
            main_x = SCREEN_WIDTH - main_width;
            main_y = screen_height - main_height;
            break;
        case 4:
            main_x = 0;
            main_y = screen_height - main_height;
            break;
        default:
            main_x = SCREEN_WIDTH/2 - main_width/2;
            main_y = screen_height/2 - main_height/2;
            break;
        }

        hwnd = ::CreateWindow(
            windowName,
            "", 
            WS_OVERLAPPEDWINDOW, 
            main_x, 
            main_y, 
            main_width, 
            main_height, 
            NULL, 
            NULL, 
            instance, 
            NULL
        );

    }

    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
    ::ShowWindow(hwnd, nWinMode);

    MSG msg; // return msg.wParam;
    if(smallWindow) {
        whereLabel = TITLE_BAR_USED_AS_LABEL;
        showWhere = false;
        widePane = false;
        HWND hdialog = ::CreateDialog(instance, "voyaSmallDialog", hwnd, (DLGPROC)smallDialogFunc);

        ::UpdateWindow(hwnd);

// ring buffer
        ring_count = produceRingBuffer(vc->titleBarMessage, SMALL_RING_COUNT);

// Preliminary thread for setting
        vs->regular_expression = false;
        vs->leftmost = PRELIMINARY_THREAD;
        threadNew(hwnd);
        thread->stop();
        threadNumber = 0;

        if(useAscii) {
            useNoCharacterButASCII();
            if(leftmost_salt) {
                vs->regular_expression = false;
                vs->leftmost = 1;
            }
        }

        if(toBeNormalized) {
            double sum = shiftJisKanaAscii();
            normalizing(sum, AIM);
            writeLabelsEditedLines();
        }

// Starting a thread
        delete thread;
        threadNew(hwnd);

        ::SetFocus(vs->stopButton);
        vs->instance = instance;
        while( ::GetMessage(&msg, NULL, 0, 0) ) {
            if(hdialog) {
                if( ::IsDialogMessage(hdialog, &msg) ) {
                    ;
                } else {
                    ::TranslateMessage(&msg);
                    ::DispatchMessage(&msg);
                }
            } else {
                ::TranslateMessage(&msg);
                ::DispatchMessage(&msg);
            }
        }

    } else {
        RECT windowRect;
        ::GetClientRect(hwnd, &windowRect);

// label
        const int WHERE_LABEL_WIDTH = windowRect.right;
        whereLabel = ::CreateWindow(
            "STATIC",
            "",
            WS_CHILD | WS_VISIBLE | SS_LEFT,
            0,
            0,
            WHERE_LABEL_WIDTH, 
            WHERE_LABEL_HEIGHT,
            hwnd,
            (HMENU)IDM_LABEL,
            instance,
            NULL
        );

        textAreaHeight = windowRect.bottom - STATUS_BAR_HEIGHT - WHERE_LABEL_HEIGHT;
        textArea = ::CreateWindow(
            "STATIC",
            "", 
            WS_CHILD | WS_VISIBLE | SS_LEFT | SS_NOPREFIX,
            0,
            WHERE_LABEL_HEIGHT,
            TEXT_AREA_WIDTH,
            textAreaHeight,
            hwnd,
            (HMENU)IDM_TEXT_AREA,
            instance,
            NULL
        );

// Common control (status bar)
        INITCOMMONCONTROLSEX cc;
        cc.dwSize = sizeof(INITCOMMONCONTROLSEX);
        cc.dwICC = ICC_LISTVIEW_CLASSES;
        ::InitCommonControlsEx(&cc); 

// status bar
        statusBar = ::CreateStatusWindowA(
            WS_CHILD | WS_VISIBLE, 
            "",
            hwnd,
            IDM_STATUS_BAR
        );

        int panel[PANEL_COUNT];
        panel[0] = COUNT_WIDTH;
        panel[1] = panel[0] + TEXT_AREA_WIDTH;
        panel[2] = panel[1] + PLEASE_WAIT_WIDTH;
        panel[3] = panel[2] + TO_STOP_WIDTH;
        panel[4] = panel[3] + LINE_COUNT_WIDTH;
        ::SendMessage(statusBar, SB_SETPARTS, (WPARAM)PANEL_COUNT, (LPARAM)panel);

// ring buffer
        ring_count = produceRingBuffer(RING_COUNT);

        ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)2 | SBT_POPOUT, (LPARAM)PLEASE_WAIT); // panel[2]
        ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)3, (LPARAM)TO_STOP); // panel[3]
        ::UpdateWindow(hwnd);

// Preliminary thread for setting
        vs->regular_expression = false;
        vs->leftmost = PRELIMINARY_THREAD;
        threadNew(hwnd);
        thread->stop();
        threadNumber = 0;

        if(useAscii) {
            useNoCharacterButASCII();
            if(leftmost_salt) {
                vs->regular_expression = false;
                vs->leftmost = 1;
            }
        }

        if(toBeNormalized) {
            double sum = shiftJisKanaAscii();
            normalizing(sum, AIM);
            writeLabelsEditedLines();
        }

// Starting a thread
        delete thread;
        threadNew(hwnd);

        HACCEL haccelerator = LoadAccelerators(instance, "voyaMenu");
        vs->instance = instance;
        while( ::GetMessage(&msg, NULL, 0, 0) ) {
            if( ::TranslateAccelerator(hwnd, haccelerator, &msg) ) {
                ;
            } else {
                ::TranslateMessage(&msg);
                ::DispatchMessage(&msg);
            }
        }
    }

    return msg.wParam;
}

LeftmostSalt::LeftmostSalt(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Leftmost salt");
}

LeftmostThread::LeftmostThread(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Leftmost");
}

long tickCount() {
    const long base = 1000000000L;
    long n = (long) ::GetTickCount();
    if(n < base) {
        n += base;
    }

    return n;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {
    using namespace _STL;

    const LPSECURITY_ATTRIBUTES DEFAULT_SECURITY = NULL;
    const LONG MUTEX = 1;
    const LPCSTR SINGLE_PROCESS = NULL;
    int button;
    NMHDR *p;
    RECT windowRect;

    switch(message) {
    case WM_COMMAND:
        switch( LOWORD(wParam) ) {
        case IDM_CENTER:
            centering(hwnd);
            break;
        case IDM_CLEAN:
            createRemoveErrorText();
            break;
        case IDM_CORNER:
            cornerHandler(hwnd);
            break;
        case IDM_CONTROL:
            thread->stop("Control");
            control = new VoyaControl(vs->instance, hwnd);
            button = control->modalDialog();
            if(button == IDC_SEARCH) {
                thread->postMessage(UM_RENEW);
            }

            delete control;
            break;
        case IDM_DETAILS:
            thread->stop("Details");
            details = new VoyaDetails(vs->instance, hwnd);
            button = details->modalDialog();
            if(button == IDD_SEARCH) {
                thread->postMessage(UM_RENEW);
            }

            delete details;
            break;
        case IDM_DIAGONAL:
            diagonalHandler(hwnd);
            break;
        case IDM_EXIT:
            closing(hwnd);
            break;
        case IDM_HEIGHT:
            heightHandler(hwnd);
            break;
        case IDM_HELP:
            ::WinHelp( (HWND)wParam, HELP_FILE_NAME, HELP_CONTEXT, IDH_OVERVIEW);
            break;
        case IDM_HERE:
            ::GetWindowRect(hwnd, &windowRect);
            main_x = windowRect.left;
            main_y = windowRect.top;
            break;
        case IDM_MINIMIZE:
            minimizeHandler(hwnd);
            break;
        case IDM_RENEW:
            thread->postMessage(UM_RENEW);
            break;
        case IDM_RIGHT:
            rightHandler(hwnd);
            break;
        case IDM_SETTING:
            thread->stop("Setting");
            setting = new VoyaSetting(vs->instance, hwnd);
            button = setting->modalDialog();
            if(button == IDI_SEARCH) {
                thread->postMessage(UM_RENEW);
            }

            delete setting;
            break;
        case IDM_SJIS:
            thread->stop("Sjis");
            sjis = new VoyaSjis(vs->instance, hwnd);
            sjis->modalDialog();
            delete sjis;
            break;
        case IDM_STANDARD:
            standardHandler(hwnd);
            break;
        case IDM_STOP:
            thread->stop();
            break;
        case IDM_TEST:
            test = new VoyaTest(vs->instance, hwnd);
            test->modalDialog();
            delete test;
            break;
        case IDM_TRACK:
            if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
                ;
            } else {
                displayEntrusted = true;  // GUI can display tori regardless of the setting (interim_report)
                ::ReleaseSemaphore(semapho, 1, NULL);
            }

            thread->postMessage(UM_MONITORING);
            break;
        case IDM_UNDER:
            underHandler(hwnd);
            break;
        case IDM_VERSION:
            version = new VoyaVersion(vs->instance, hwnd);
            version->modalDialog();
            delete version;
            break;
        case IDM_VYBM:
            shellExcute(VYBM_EXE, "");
            break;
        case IDM_WIDTH:
            widthHandler(hwnd);
            break;
        }

        break;
    case UM_MONITORING:
        if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
            break;
        } else {
            if(displayEntrusted) {
                if(smallWindow) {
                    newTitleBar(hwnd);
                    ::SetFocus(vs->stopButton);
                } else {
                    showRing(hwnd);
                }

                displayEntrusted = false;
            }

            ::ReleaseSemaphore(semapho, 1, NULL);
        }

        break;
    case UM_RENEW:
        thread->stop("Version or status");

        if( settingBy(VOYA_CSV) ) {
            readLabels();
        } else {
            closing(hwnd);
        }

        delete thread;
        threadNew(hwnd);
        break;
    case WM_CLOSE: 
        closing(hwnd);
        break;
    case WM_CREATE: 
        semapho = ::CreateSemaphore(DEFAULT_SECURITY, 1, MUTEX, SINGLE_PROCESS);
        ::SetTimer(hwnd, IDM_TIMER, vs->non_sampling, (TIMERPROC)TimerProc);
        break;
    case WM_DESTROY:
        ::PostQuitMessage(0);
        break;
    case WM_NOTIFY:
        p = (NMHDR *)lParam;
        switch(p->idFrom) {
        case IDM_STATUS_BAR:
            if(p->code == NM_CLICK) {
                thread->postMessage(UM_RENEW);
            }

            break;
        }

        break;
    case WM_SIZE:
        ::SendMessage(statusBar, WM_SIZE, wParam, lParam);
        layout(hwnd);
        break;
    default: 
        return ::DefWindowProc(hwnd, message, wParam, lParam);
    }

    return 0;
}

PreliminaryThread::PreliminaryThread(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Preliminary");
}

RegularExpression::RegularExpression(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Regular expression");
}

RightmostThread::RightmostThread(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Rightmost");
}

StandardThread::StandardThread(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Standard");
}

UnlessCaseSensitive::UnlessCaseSensitive(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Unless case-sensitive");
}

UpperCaseRightmost::UpperCaseRightmost(HWND h, HWND w) {
    hwnd = h;
    terminating_period = period;
    whereLabel = w;
    openVoyaError();
    ::SetWindowText(hwnd, "Uppercase rightmost");
}

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
    if(smallWindow) {
        ;
    } else {
        thread->movingInside(showWhere);
    }

    thread->postMessage(UM_MONITORING);
}

void centering(HWND hwnd) {
    corner = 0;

    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    main_x = SCREEN_WIDTH/2 - main_width/2;
    main_y = screen_height/2 - main_height/2;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);

    standard_main_x = main_x;
    standard_main_y = main_y;
}

void closing(HWND hwnd) {
    if( thread->closing() ) {
        delete thread;

        ::DestroyWindow(hwnd);
    } // Stop the thread before closing

}

void cornerHandler(HWND hwnd) {
    corner = 1;

    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
    }

    main_x = 0;
    main_y = 0;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void defaultWeight() {
    int a[ARRAY_LENGTH] = {1, 0, 524287, 400, 143, 1, 1, 1, 1, 1, 1, 1, 1, 143, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    vs->ascii_weight = a[4];
    vs->capital_omega_weight = a[5];
    vs->capital_ya_weight = a[6];
    vs->capital_z_weight = a[7];
    vs->cap_weight = a[8];
    vs->circle_weight = a[9];
    vs->cup_weight = a[10];
    vs->double_integral_weight = a[11];
    vs->exists_weight = a[12];
    vs->hankaku_katakana_weight = a[13];
    vs->heisei_weight = a[14];
    vs->hiragana_weight = a[15];
    vs->jis_level_one_kanji_weight = a[16];
    vs->jis_level_two_kanji_weight = a[17];
    vs->katakana_weight = a[18];
    vs->keisen_weight = a[19];
    vs->nine_weight = a[20];
    vs->omega_weight = a[21];
    vs->paragraph_weight = a[22];
    vs->parallel_weight = a[23];
    vs->roman_weight = a[24];
    vs->square_meter_weight = a[25];
    vs->ya_weight = a[26];
    vs->z_weight = a[27];
}

void diagonalHandler(HWND hwnd) {
    corner = 3;

    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
    }

    main_x = SCREEN_WIDTH - main_width;
    main_y = screen_height - main_height;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void heightHandler(HWND hwnd) {
    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    RECT windowRect;

    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
    }

    screen_height += MENU_HEIGHT;
    ::GetWindowRect(hwnd, &windowRect);
    main_x = windowRect.left;
    main_y = windowRect.top;

    if(longPane) {
        longPane = false;
        main_height = MAIN_HEIGHT;
    } else {
        longPane = true;
        main_height = LONG_PANE;
        int y = screen_height - LONG_PANE;
        if(y < main_y) {
             main_y = y;
        }

    }

    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void layout(HWND hwnd) {
    using namespace _STL;

    int height;
    RECT windowRect;
    ::GetClientRect(hwnd, &windowRect);

// label
    const int WHERE_LABEL_WIDTH = windowRect.right;
    ::MoveWindow(whereLabel, 0, 0, WHERE_LABEL_WIDTH, WHERE_LABEL_HEIGHT, REPAINT);

// line count ( threadNew() will produce a new ring buffer.)
    height = windowRect.bottom - STATUS_BAR_HEIGHT - WHERE_LABEL_HEIGHT;
    ring_count = RING_COUNT * height/398;
    if(ring_count > MAXIMUM_RING_COUNT) {
        ring_count = MAXIMUM_RING_COUNT;
    }

    stringstream ss;
    ss << ring_count << " lines";
    const string s = ss.str();
    ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)4, (LPARAM)s.c_str() );

// text area
    textAreaHeight = windowRect.bottom - STATUS_BAR_HEIGHT - WHERE_LABEL_HEIGHT;
    ::MoveWindow(textArea, 0, WHERE_LABEL_HEIGHT, TEXT_AREA_WIDTH, textAreaHeight, REPAINT);
    ::SetWindowText(textArea, areaText);
}

void minimizeHandler(HWND hwnd) {
    WINDOWPLACEMENT wp;

    if( ::GetWindowPlacement(hwnd, &wp) ) {
        wp.showCmd = SW_MINIMIZE;
        ::SetWindowPlacement(hwnd, &wp);
    }
}

void newTitleBar(HWND hwnd) {
    using namespace _STL;

    RING::reverse_iterator i = ring.rbegin();
    string s = *i;
    lstrcpy(titleBar, s.c_str() );
    ::SetWindowText(hwnd, titleBar);
}

void rightHandler(HWND hwnd) {
    corner = 2;

    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);

    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
    }

    main_x = SCREEN_WIDTH - main_width;
    main_y = 0;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void showRing(HWND hwnd) {
    using namespace _STL;

    const int PIPE_GAP_SIZE = 2;
    const string GAP_PIPE(" |");
    const string GAP(" "); // gap provided for word wrapping
    const string PIPE_GAP("| ");
    int q;
    string head("");
    string tail, total_pipe_tori;
    stringstream ss;
    for(RING::iterator i = ring.begin(); i != ring.end(); ++i) {
        total_pipe_tori = *i;
        q = total_pipe_tori.rfind(PIPE_GAP);
        if(q != string::npos) {
            q += PIPE_GAP_SIZE;
            head = total_pipe_tori.substr(0, q);
            tail = total_pipe_tori.substr(q);
            ss << tail << GAP;
        }
    }

/* text area 
        textArea = ::CreateWindow(
            "STATIC",
            "", 
            WS_CHILD | WS_VISIBLE | SS_LEFT,*/
    string s = ss.str();
    lstrcpy(areaText, s.c_str() );
    ::SetWindowText(textArea, areaText);

// status bar
    q = head.find(GAP_PIPE);
    if(q != string::npos) {
        head = total_pipe_tori.substr(0, q);
    }

    ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)0, (LPARAM)head.c_str() ); // panel[0]
    ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)1, (LPARAM)tail.c_str() ); // panel[1]
    ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)2 | SBT_POPOUT, (LPARAM)waiting); // panel[2]
    ::SendMessage(statusBar, SB_SETTEXT, (WPARAM)3, (LPARAM)TO_STOP); // panel[3]
// layout() sets the text of panel[4].
}

void standardHandler(HWND hwnd) {
    longPane = false;
    widePane = false;
    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
        main_x = SMALL_WINDOW_X;
        main_y = SMALL_WINDOW_Y;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
        corner = 0;
        main_x = standard_main_x;
        main_y = standard_main_y;
        main_height = MAIN_HEIGHT;
        main_width = MAIN_WIDTH;
    }

    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void threadNew(HWND hwnd) {
    lstrcpy(waiting, TO_SEARCH);

    if( ::WaitForSingleObject(semapho, WAITED_TOO_LONG) == WAIT_TIMEOUT ) {
        ;
    } else {
        displayEntrusted = true;  // GUI can display tori regardless of the setting (interim_report)
        ::ReleaseSemaphore(semapho, 1, NULL);
    }

    if(smallWindow) {
        ring_count = produceRingBuffer(vc->titleBarMessage, SMALL_RING_COUNT);
    } else {
        ring_count = produceRingBuffer(ring_count);
    }

    if(vs->regular_expression) {
        if(vs->dragon_seek) {
            thread = new DragonSeek(hwnd, whereLabel);
        } else {
            thread = new RegularExpression(hwnd, whereLabel);
        }
    } else {
        switch(vs->leftmost) {
        case PRELIMINARY_THREAD:
            thread = new PreliminaryThread(hwnd, whereLabel);
            break;
        case -1:
            if(vs->lower_case) {
                thread = new RightmostThread(hwnd, whereLabel);
            } else {
                thread = new UpperCaseRightmost(hwnd, whereLabel);
            }

            break;
        case 0:
            if(vs->case_sensitive) {
                thread = new StandardThread(hwnd, whereLabel);
            } else {
                thread = new UnlessCaseSensitive(hwnd, whereLabel);
            }

            break;
        default:
            if(vs->leftmost_salt) {
                thread = new LeftmostSalt(hwnd, whereLabel);
            } else {
                thread = new LeftmostThread(hwnd, whereLabel);
            }

        }

    }

    thread->startSuspend();
    untouched = thread->readVoyaCtrlText();
    thread->restart();
    threadNumber += 1;
    if(threadNumber == 1) {
        thread->setMessages(messages);
    }

    wsprintf(voyaThreadNumber, "voya Thread-%d", threadNumber);

    if(smallWindow) {
        ::SetFocus(vs->stopButton);
    } else {
// title bar
        thread->setWindowText(voyaThreadNumber);
    }
}

void underHandler(HWND hwnd) {
    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
    }

    main_x = 0;
    main_y = screen_height - main_height;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void widthHandler(HWND hwnd) {
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    RECT windowRect;

    if(smallWindow) {
        main_height = SMALL_WINDOW_HEIGHT;
        main_width = SMALL_WINDOW_WIDTH;
    } else {
        ::ShowWindow(hwnd, SW_RESTORE);
    }

    ::GetWindowRect(hwnd, &windowRect);
    main_x = windowRect.left;
    main_y = windowRect.top;

    if(widePane) {
        widePane = false;
        main_width = MAIN_WIDTH;

    } else {
        widePane = true;
        main_width = WIDE_PANE;
        int x = SCREEN_WIDTH - WIDE_PANE;
        if(x < main_x) {
             main_x = x;
        }

    }

    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

