#ifndef VOYA_THREAD_H
#define VOYA_THREAD_H

#pragma warn -8004
#pragma warn -8026
#pragma warn -8057
#pragma warn -8071

#define ASCII_COUNT 95
#define ASCII_SET_ARRAY_SIZE 256
#define COMPLEMENT "/.."
#define COUNT_WIDTH 80
#define EXTENDED_TABLE_SIZE 65536 // unsigned 16-bit integers
#define FROM_TO " -> "
#define HALF 128 // int BIT = 1; HALF = BIT << 7;
#define KANJI_SIZE_PLUS_ONE 3
#define LINE_COUNT_WIDTH 60
#define LONG_PANE 651
#define MAIN_HEIGHT 499
#define MAIN_WIDTH 401
#define MAIN_X 279
#define MAIN_Y 30
#define MAXIMUM_RING_COUNT 36
#define NON_TORI_LINE " _/_/_/_/_/"
#define PANEL_COUNT 6
#define PLEASE_WAIT "Please wait."
#define PLEASE_WAIT_TWO "Please wait two minutes."
#define PLEASE_WAIT_WIDTH 70
#define REVERSE_COMPLEMENT "../"
#define SALT_SET_ARRAY_SIZE 128
#define SMALL_BUTTON_HEIGHT 29
#define SMALL_BUTTON_WIDTH 50
#define SMALL_BUTTON_X 213
#define SMALL_BUTTON_Y 2
#define SMALL_WINDOW_HEIGHT 61
#define SMALL_WINDOW_WIDTH 276
#define SMALL_WINDOW_X 374
#define SMALL_WINDOW_Y 361
#define STATUS_BAR_HEIGHT 20
#define SUM_EQUALS_ZERO "The sum of weight equals zero."
#define TABLE_SIZE 7552 // > 7338 + 63 + 95
#define TEXT_AREA_WIDTH 106
#define TIME_USED_AS_SEED 0L
#define TITLE_BAR_TEXT "titleBar.txt"
#define TITLE_BAR_USED_AS_LABEL 0
#define TO_SEARCH "Search"
#define TO_STOP "Alt + S, Alt + P to stop."
#define TO_STOP_WIDTH 140
#define TOO_LARGE_SUM "Large sum of weight. "
#define TOTAL_COLON "Total: "
#define TSEU_LENGTH 3
#define UM_MONITORING (WM_APP + 1) 
#define UM_RENEW (WM_APP + 2) 
#define WHERE_LABEL_HEIGHT 25
#define WIDE_PANE 784
#include <deque>
#include <fstream>
#include <iostream>
#include <regexp>
#include <sstream>
#include <vector>
#include "Controllable.h" // class Thread
#include "ModalDialog.h"
#include <commctrl.h>
#include "voyaControl.h"
#include "voyaID.h"
#include "voyaSetting.h"
#include "voyaSjis.h"
#include "voyaTest.h"

typedef _STL::deque<_STL::string> RING;
typedef char* (*CRYPT)(char*, char*);

class DragonSeek : public Controllable {
public:
    DragonSeek(HWND h, HWND w);
    ~DragonSeek(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class LeftmostSalt : public Controllable {
public:
    LeftmostSalt(HWND h, HWND w);
    ~LeftmostSalt(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class LeftmostThread : public Controllable {
public:
    LeftmostThread(HWND h, HWND w);
    ~LeftmostThread(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class Numbered {
    char *p;
    int length, span, non_number_length;
    std::string *f;
    std::string *s;

public:
    ~Numbered() {
        delete f;
        delete p;
        delete s;
    }

    Numbered(char *a) {
        using namespace std;

        length = strlen(a);
        p = new char[ length + 1 ];

// Copying all
        strcpy(p, a);
        span = strspn(strrev(p), "0123456789");
        non_number_length = length - span;

// Copying the second part of a
        memcpy(p, a + non_number_length, span);
        p[span] = '\0';
        s = new string(p);

// Copying the first part of a
        memcpy(p, a, non_number_length);
        p[non_number_length] = '\0';
        f = new string(p);
    }

    Numbered(std::string & a) {
        using namespace std;

        length = a.length();
        p = new char[ length + 1 ];

// Copying all
        strcpy(p, a.c_str() );
        span = strspn(strrev(p), "0123456789");
        non_number_length = length - span;
        string head = a.substr(0, non_number_length);
        string tail = a.substr(non_number_length);

// Copying the second part of a
        s = new string(tail);

// Copying the first part of a
        f = new string(head);
    }

    int number() const {
        char *stop;
        int n = (int)strtol(s->c_str(), &stop, 10);
        return n;
    }

    std::string numberString() const {
        return *s;
    }

    std::string parameter() const {
        return *f;
    }

};

class PreliminaryThread : public Controllable {
public:
    PreliminaryThread(HWND h, HWND w);
    ~PreliminaryThread(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class RegularExpression : public Controllable {
public:
    RegularExpression(HWND h, HWND w);
    ~RegularExpression(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class RightmostThread : public Controllable {
public:
    RightmostThread(HWND h, HWND w);
    ~RightmostThread(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class StandardThread : public Controllable {
public:
    StandardThread(HWND h, HWND w);
    ~StandardThread(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class UnlessCaseSensitive : public Controllable {
public:
    UnlessCaseSensitive(HWND h, HWND w);
    ~UnlessCaseSensitive(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

class UpperCaseRightmost : public Controllable {
public:
    UpperCaseRightmost(HWND h, HWND w);
    ~UpperCaseRightmost(){}
    DWORD WINAPI ThreadFunc(LPVOID param);
};

bool readVoyaCtrlTextBeforeCreatingWindow();
bool repeating(); // bound
char lowerCaseOf(int i);
char random_ascii(char *ascii_array); // voyaFile.cpp
char upperCaseOf(int i);
double shiftJisKanaAscii(); // bound
int charToInteger(char c);
int produceRingBuffer(_STL::string & message, int size);
int produceRingBuffer(int size);
int sumOfWeight(double sum);
int WINAPI WinMain(HINSTANCE instance, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode);
long tickCount();
LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
unsigned long randomIndex();
VOID CALLBACK renew(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);
VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);
void cornerHandler(HWND hwnd);
void defaultWeight();
void diagonalHandler(HWND hwnd);
void heightHandler(HWND hwnd);
void layout(HWND hwnd);
void minimizeHandler(HWND hwnd);
void newTitleBar(HWND hwnd);
void random_salt(char *salt, char *salt_array); // voyaFile.cpp
void rightHandler(HWND hwnd);
void setMT(long n, int repetition);
void showRing(HWND hwnd);
void standardHandler(HWND hwnd);
void centering(HWND hwnd);
void closing(HWND hwnd);
void threadNew(HWND hwnd);
void underHandler(HWND hwnd);
void widthHandler(HWND hwnd);

#endif // VOYA_THREAD_H
