#ifndef MODAL_DIALOG_H
#define MODAL_DIALOG_H

#pragma warn -8057

#define VERSION 1.03
#define MANAGE_TEXT "manage.txt"
#define END_START_LIST_SIZE 25
#define HELP_FILE_NAME "VYBM.HLP"
#define TINY_BUFFER_SIZE 12
#define VERSION_TEXT "version.txt"
#include <fstream>
#include <iostream>
#include <sstream>
#include <windows.h>
#include "vybmID.h"

class ModalDialog {
protected:
    HINSTANCE instance;
    HWND hwnd, hdwnd, infoLabel;
    int infoLabelHeight, infoLabelID, infoLabelWidth, infoLabelX, infoLabelY, width, height;
    std::string info;

public:
    virtual ~ModalDialog(){}

    void centering();
    void clear();
    void inform();
    void postMessage(int UM);
    void setWindowText(char *s);

    virtual BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam) = 0;
    virtual int modalDialog() = 0;
};

class VybmManage : public ModalDialog {
    bool backUp, narrowPane, removeFirst, serialNumber, shortPane, widePane;
    const int INFO_LABEL_HEIGHT, MANAGE_HEIGHT, MANAGE_WIDTH;

    bool writeManageText();

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VybmManage(HINSTANCE i, HWND h);
    void setting(bool backUp, bool narrowPane, bool removeFirst, bool serialNumber, bool shortPane);
};

BOOL CALLBACK manageDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);

class VybmVersion : public ModalDialog {
    const int INFO_LABEL_HEIGHT, VERSION_HEIGHT, VERSION_WIDTH;

public:
    BOOL CALLBACK DialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
    int modalDialog();
    VybmVersion(HINSTANCE i, HWND h);
};

BOOL CALLBACK versionDialogFunc(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
void createVersionText(bool comments);

#endif // MODAL_DIALOG_H
