#include "TimeName.h"

static int sn; // TimeName::setSerialNumber()

bool AfterBefore::readAfterNameText() {
	using namespace std;

	char c[BUFFER_SIZE];
	string afterName(AFTER_NAME);
	string beforeName(BEFORE_NAME);

	ifstream in(AFTER_NAME_TEXT);
	if( in.fail() ) {
		acquired = false;
		return false;
	}

	string s;
	string *p = new string("");
	while( in.getline(c, BUFFER_SIZE) ) {
		delete p;
		p = new string(c);
		s = *p;
		if( match_include(s) ) {
			break;
		}
	}

	delete p;
	in.close();

	if(! beforeAfterName() ) {
		after = afterName;
		before = beforeName;
		acquired = true;
	}

	return acquired;
}

int zenkakuFragment(std::string & s, int mark_index, int mark) {
    using namespace std;

    bool zenkaku = false;
    char line[BUFFER_SIZE];
    const int AFTER_MARK = mark_index + 1;
    int c;
    int firstOrSecondByte = 0;
    int lineLength = s.length();
    unsigned char byte;

    strcpy(line, s.c_str() );
    for(int i = 0; i < lineLength && i < AFTER_MARK; ++i) {
        byte = (unsigned char)line[i];
        c = (int)byte;

        if(zenkaku) {
            firstOrSecondByte = SECOND_BYTE;
            if(i == mark_index) {
                break;
            } else {
                zenkaku = false;
                firstOrSecondByte = 0;
                continue;
            }
        }

        if(0x81 <= c && c <= 0xFC) {
            if(KANA_KUTEN <= c && c <= 0xDF) { // 
                zenkaku = false;
                firstOrSecondByte = 0;
            } else {
                zenkaku = true;
                firstOrSecondByte = FIRST_BYTE;
            }

        } else {
            zenkaku = false;
            firstOrSecondByte = 0;
            if(c == mark) {
                if(i == mark_index) {
                    break;
                }
            }
        }
    }

    return firstOrSecondByte;
}

std::string TimeName::temporaryName(bool serial_number) {
    using namespace std;

    int m, sec;
    struct tm *time_block;
    time_t timer;
    timer = time(NULL);
    time_block = localtime(&timer);
    m = time_block->tm_min;
    sec = time_block->tm_sec;

    if(serial_number) {
        setSerialNumber();
    }

    stringstream os;
    os << name << m << HYPHEN << sec << extension;
    string ti = os.str();
    if(ti == timeName) {
        setSerialNumber();

        stringstream om;
        om << name << m << HYPHEN << sec << extension;
        ti = om.str();
    }

    timeName = ti;
    return timeName;
}

void TimeName::readSerialNumber() {
    using namespace std;

    char buffer[BUFFER_SIZE];
    ifstream buffered(SERIAL_TEXT);
    if( buffered.getline(buffer, BUFFER_SIZE) ) {
        string line(buffer);
        stringstream os(line);
        os >> sn;
    } else {
        zeroSerialNumber();
    }
}

void TimeName::setSerialNumber() {
    using namespace std;

    ++sn;
    ofstream file(SERIAL_TEXT);
    file << sn << endl;

    stringstream os;
    os << base << sn << HYPHEN;
    const string na = os.str();
    name = na;
}

void TimeName::zeroSerialNumber() {
    using namespace std;

    sn = 0;
    ofstream file(SERIAL_TEXT);
    file << sn << endl;
}

