#ifndef VYBM_H
#define VYBM_H

#include "TimeName.h"
#include "ModalDialog.h"
#include <commctrl.h>
#include "Dividable.h"
#include "vybmID.h"
#include "struct_vs.h"
#include <vector>

enum PAGES {page7, page1, page2, page3, page4, page5, page6, PAGE_COUNT};
enum TABS {SETTING_TAB, ASCII_TAB, CYRILLIC_TAB, GREEK_TAB, KANJI_TAB, MATHEMATICAL_TAB, SALT_TAB, TAB_COUNT};
enum VOYA_CSV_LINES {UNAVAILABLE, REQUEST_LINE, LOG_LINE, LEFTMOST_LINE, CASE_SENSITIVE_LINE, REPORT_LINE, IDLING_LINE, ASCII_LINE};

typedef struct GROUP_VALUE GROUP_VALUE;
struct GROUP_VALUE {
    double w;
    int height, length, width, x, y;
    char buffer[SMALL_BUFFER_SIZE];
};

bool copyEdited(int n, char *buffer);
bool copyLabel(int n, std::string & label);
bool createRemoveErrorText();
bool movingInside(HWND hwnd, bool showWhere);
bool readVoyaCSV();
bool readManageText();
bool removeTemporaryFiles();
bool touchVoyaCtrlText();
bool voya_vybm_rearrange();
bool voyaLogBatchProcessing();
bool vybm_voya_rearrange();
bool withinRange(int n);
double shiftJisKanaAscii(); // bound
double summing(bool status_bar);
int checkKanji(char *c, int length);
int groupColumn(HWND hwnd);
int sumOfWeight(double sum);
int valueColumn(HWND hwnd);
int WINAPI WinMain(HINSTANCE instance, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode);
LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
VOID CALLBACK batchProcessing(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);
VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime);
void centering(HWND hwnd);
void closing();
void cornerHandler(HWND hwnd);
void createManageText();
void diagonalHandler(HWND hwnd);
void editedLinePrint(int i, int a);
void heightHandler(HWND hwnd);
void layout(HWND hwnd);
void minimizeHandler(HWND hwnd);
void narrowHeader(HWND hwnd);
void normalizing(double sum, double aim);
void omit(HWND hwnd);
void recovery(bool r);
void rightHandler(HWND hwnd);
void selectTab(HWND hwnd, int page);
void standardHeader(HWND hwnd, bool perfect);
void underHandler(HWND hwnd);
void widthHandler(HWND hwnd);
void writeLabelsEditedLines();

#endif // VYBM_H
